SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Fakes'!
SystemOrganization addCategory: #'Monticello2-Repositories'!
SystemOrganization addCategory: #'Monticello2-Slices'!
SystemOrganization addCategory: #'Monticello2-Tests'!
SystemOrganization addCategory: #'Monticello2-Utilities'!
SystemOrganization addCategory: #'Monticello2-Versions'!

!MethodReference methodsFor: '*monticello2' stamp: 'cwp 3/3/2005 02:15'!
asElement
	^ MDMethodElement 
		className: classSymbol 
		selector: methodSymbol
		classIsMeta: classIsMeta! !

!Symbol class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:03'!
materializeWith: aMarshal
	^ aMarshal readSymbol! !

!SmallInteger class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:21'!
materializeWith: aMarshal
	^ aMarshal readSmallInteger! !

Object subclass: #MDByteIndex
	instanceVariableNames: 'keySize valueSize streamSize stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2005 03:08'!
stream: aStream keySize: keyNumber valueSize: valueNumber
	^ self stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: aStream size! !

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/19/2005 02:41'!
stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	^ self basicNew setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray
	^ self at: keyArray ifAbsent: [self error: 'Could not find key ', keyArray printString]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray ifAbsent: errorBlock
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	^ self basicAt: keyArray ifAbsent: errorBlock! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:37'!
at: keyArray put: valueArray
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	valueArray size = valueSize ifFalse: [self error: 'Value must be exactly ', valueSize asString, ' bytes'].
	^ self basicAt: keyArray put: valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:34'!
basicAt: keyArray ifAbsent: errorBlock
	| i key |
	i _ self scanFor: keyArray.
	key _ self keyBytesAtIndex: i.
	^ key = keyArray
		ifTrue: [self valueBytesAtIndex: i]
		ifFalse: errorBlock! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
basicAt: keyArray put: valueArray
	| i key |
	i _ self scanFor: keyArray.
	key _ self keyBytesAtIndex: i.
	key = keyArray ifFalse:
		[self writeTally: self tally + 1.
		self writeKeyBytes: keyArray atIndex: i].
	self writeValueBytes: valueArray atIndex: i.
	^ valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:45'!
hash: keyArray
	^ keyArray hash! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:38'!
keyBytesAtIndex: i
	self seekTo: i.
	^ stream atEnd
		ifTrue: [ByteArray new: keySize]
		ifFalse: [stream next: keySize]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
keySize
	^ keySize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:07'!
maxIndex
	^ streamSize - 4 // self recordSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:43'!
recordSize
	^ keySize + valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:33'!
scanFor: keyArray
	| start |
	start _ (self hash: keyArray) \\ self maxIndex.
	start to: self maxIndex do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	0 to: start - 1 do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	
	self error: 'Index is full'! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:29'!
scanFor: keyArray at: i
	| key |
	key _ self keyBytesAtIndex: i.
	^ key = keyArray or: [key allSatisfy: [:b | b = 0]]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
seekTo: i
	stream position: i * self recordSize + 4! !

!MDByteIndex methodsFor: 'initialize-release' stamp: 'avi 3/19/2005 02:41'!
setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	keySize _ keyNumber.
	valueSize _ valueNumber.
	streamSize _ streamNumber.
	stream _ aStream.
	stream binary! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/19/2005 02:51'!
streamSize
	^ streamSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/15/2005 03:23'!
tally
	stream reset.
	^ stream atEnd
		ifTrue: [0]
		ifFalse: [stream nextInt32]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:41'!
valueBytesAtIndex: i
	self seekTo: i.
	stream skip: keySize.
	^ stream next: valueSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
valueSize
	^ valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeKeyBytes: keyBytes atIndex: i
	self seekTo: i.
	stream nextPutAll: keyBytes! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
writeTally: aNumber
	stream reset.
	stream nextInt32Put: aNumber! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeValueBytes: valueBytes atIndex: i
	self seekTo: i.
	stream skip: keySize.
	stream nextPutAll: valueBytes! !

Object subclass: #MDFakeElementAdaptor
	instanceVariableNames: 'image element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/4/2005 00:35'!
forElement: anElement inImage: aDictionary
	^ self new setImage: aDictionary element: anElement! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:29'!
checkDependencies
	self isLoadable ifFalse: [self error: 'Unmet dependency']! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 5/24/2005 07:54'!
display: properties
	^ properties one asString! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:31'!
isLoadable
	| required |
	(element name includes: $/) ifFalse: [^ true].
	required := element name copyUpTo: $/.
	^ image keys anySatisfy: [:ea | ea name = required]
! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/13/2005 19:44'!
isLoadable: properties
	^ self isLoadable! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:36'!
isPresent
	^ image includesKey: element! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:39'!
isUpToDate: properties
	properties keysAndValuesDo: 
		[:key :value |
		(self properties at: key ifAbsent: [^ false]) = value ifFalse: [^ false]].
	^ true
	! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 3/25/2005 22:03'!
load: properties 
	self checkDependencies.
	self properties.
	properties keysAndValuesDo: [:key :value | self properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'avi 3/16/2005 12:33'!
merge: aPropertyDictionary into: otherPropertyDictionary onFailure: aBlock
	^ aBlock value! !

!MDFakeElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/13/2005 18:17'!
properties
	^ image at: element ifAbsentPut: [Dictionary new]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:40'!
remove
	image removeKey: element ifAbsent: []! !

!MDFakeElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 2/4/2005 00:34'!
setImage: aFakeImageProxy element: anElement
	image _ aFakeImageProxy.
	element _ anElement! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:33'!
update: properties
	self properties keysAndValuesDo: [:key :value | properties at: key put: value]! !

Object subclass: #MDHashedObject
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDHashedObject class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:51'!
extension
	self subclassResponsibility! !

!MDHashedObject class methodsFor: 'serialization' stamp: 'cwp 8/9/2005 21:01'!
materializeWith: aMarshall
	^ aMarshall readHashedObject: self basicNew! !

!MDHashedObject methodsFor: 'accessing' stamp: 'cwp 8/9/2005 21:43'!
hashstamp
	^ cache! !

!MDHashedObject methodsFor: 'initialize-release' stamp: 'cwp 8/9/2005 21:44'!
initHashstamp
	cache _ MDHashstamp 
					forObject: self 
					timestamp: cache! !

!MDHashedObject methodsFor: 'initialize-release' stamp: 'cwp 8/9/2005 21:44'!
initialize
	cache _ MDTimestamp now.! !

!MDHashedObject methodsFor: 'serialization' stamp: 'cwp 8/9/2005 20:44'!
serializeWith: aMarshall
	aMarshall writeHashedObject: self! !

!MDHashedObject methodsFor: 'accessing' stamp: 'cwp 8/9/2005 21:44'!
timestamp
	^ cache timestamp! !

MDHashedObject subclass: #MDSnapshot
	instanceVariableNames: 'meta contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDSnapshot class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:52'!
extension
	^ 'snap'! !

!MDSnapshot class methodsFor: 'instance creation' stamp: 'cwp 3/23/2005 22:52'!
withVersions: versions
	^ self new setVersions: versions! !

!MDSnapshot methodsFor: 'comparing' stamp: 'cwp 4/10/2005 12:43'!
= other
	^ self species = other species 
		and: [self meta = other meta]
		and: [self contents = other contents]! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 3/27/2005 22:39'!
contents
	^ contents! !

!MDSnapshot methodsFor: 'repository' stamp: 'cwp 3/27/2005 22:38'!
getVersionsFrom: aRepository
	^ meta, contents collect: [:ea | aRepository get: ea]! !

!MDSnapshot methodsFor: 'comparing' stamp: 'cwp 4/10/2005 12:43'!
hash
	^ self meta hash bitXor: self contents hash! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 3/27/2005 22:39'!
meta
	^ meta! !

!MDSnapshot methodsFor: 'initialize-release' stamp: 'cwp 8/9/2005 20:57'!
setVersions: aSet
	meta _ Set new.
	contents _ Set new.
	aSet do: [:ea | ea element isMeta 
					ifTrue: [meta add: ea hashstamp] 
					ifFalse: [contents add: ea hashstamp]].
	self initHashstamp.! !

MDHashedObject subclass: #MDVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

MDVersion subclass: #MDElementVersion
	instanceVariableNames: 'variant ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 10/16/2005 14:19'!
variant: aVariant 
	^self variant: aVariant ancestry: Set new! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 10/16/2005 14:18'!
variant: aVariant ancestry: aSet 
	^self 
		variant: aVariant
		ancestry: aSet
		timestamp: MDTimestamp now! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 10/16/2005 14:18'!
variant: aVariant ancestry: aSet timestamp: aTimeStamp 
	^self basicNew 
		setVariant: aVariant
		ancestry: aSet
		timestamp: aTimeStamp! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:53'!
ancestry
	^ ancestry! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 13:50'!
element
	^variant element! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 3/23/2005 23:15'!
fullAncestry
	^ancestry copyWith: self hashstamp! !

!MDElementVersion methodsFor: 'comparing' stamp: 'cwp 3/23/2005 23:15'!
precedes: aVersion 
	^aVersion ancestry includes: self hashstamp! !

!MDElementVersion methodsFor: 'conflicts' stamp: 'cwp 10/16/2005 14:07'!
resolveConflictWith: aVersion in: anImageProxy using: twoArgBlock 
	(self variant autoMergeWith: aVersion variant in: anImageProxy) 
		ifNotNilDo: [:snap | ^snap].
	^twoArgBlock value: self value: aVersion! !

!MDElementVersion methodsFor: 'initialize-release' stamp: 'cwp 10/16/2005 14:15'!
setVariant: aVariant ancestry: aCollection timestamp: aTimestamp 
	variant := aVariant.
	ancestry := aCollection.
	cache := aTimestamp.
	self initHashstamp! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 13:50'!
variant
	^variant! !

MDVersion subclass: #MDNullVersion
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDNullVersion class methodsFor: 'as yet unclassified' stamp: 'cwp 2/27/2005 21:31'!
forElement: anElement
	^ self new setElement: anElement! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
ancestry
	^ Set new! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:36'!
element
	^ element! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
fullAncestry
	^ Set new! !

!MDNullVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
precedes: anElementVersion 
	^true! !

!MDNullVersion methodsFor: 'initialize-release' stamp: 'cwp 8/9/2005 20:57'!
setElement: anElement
	element _ anElement.
	self initHashstamp! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 13:45'!
snapshot
	^ MDRemovalVariant forElement: element! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 14:17'!
variant
	^ MDRemovalVariant forElement: element! !

!MDVersion class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:53'!
extension
	^ 'vers'! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 4/10/2005 12:41'!
= other
	^ self species = other species and: [self hashstamp = other hashstamp]! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 3/2/2005 22:22'!
conflictsWith: other
	^ ((self precedes: other) or: [self succeeds: other]) not! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 4/10/2005 12:41'!
hash
	^self hashstamp hash! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
succeeds: anElementVersion 
	^anElementVersion precedes: self! !

!MDVersion methodsFor: 'comparing' stamp: 'avi 3/21/2006 00:13'!
successor: other 
	(self = other) ifTrue: [^ self].
	(self succeeds: other) ifTrue: [^ self].
	(other succeeds: self) ifTrue: [^ other].
	^ nil! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 10/16/2005 14:18'!
successor: other onConflict: aBlock 
	(self succeeds: other) ifTrue: [^self].
	(other succeeds: self) ifTrue: [^other].
	^MDElementVersion variant: aBlock value
		ancestry: self fullAncestry , other fullAncestry! !

Object subclass: #MDImageElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageElement commentStamp: 'cwp 5/7/2006 22:29' prior: 0!
I am an abstract superclass. My subclasses are references to the parts of a Smalltalk program. 
!

MDImageElement subclass: #MDClassCommentElement
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassCommentElement commentStamp: 'cwp 5/7/2006 22:32' prior: 0!
I am a reference to the comment of a particular class.

theClassName - the name of the class to whose comment I refer

!

!MDClassCommentElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol 
	^ self basicNew setClassName: aSymbol! !

!MDClassCommentElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 02:03'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]! !

!MDClassCommentElement methodsFor: 'adapting' stamp: 'cwp 2/12/2005 14:03'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassCommentElement: self! !

!MDClassCommentElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 02:05'!
hash
	^ theClassName hash! !

!MDClassCommentElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:07'!
isIncludedInSlice: aSlice
	^ aSlice includesClassComment: self! !

!MDClassCommentElement methodsFor: 'printing' stamp: 'cwp 9/3/2005 22:44'!
printDebugIdOn: aStream
	aStream
		nextPutAll: theClassName;
		nextPut: $-;
		nextPutAll: 'comment'! !

!MDClassCommentElement methodsFor: 'initialize-release' stamp: 'cwp 3/3/2005 02:05'!
setClassName: aSymbol 
	theClassName := aSymbol! !

!MDClassCommentElement methodsFor: 'accessing' stamp: 'cwp 3/3/2005 02:05'!
theClassName
	^ theClassName! !

MDImageElement subclass: #MDClassElement
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassElement commentStamp: 'cwp 5/7/2006 22:34' prior: 0!
I am a reference to a class.

theClassName - the name of the class
!

!MDClassElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol
	^ self basicNew setClassName: aSymbol! !

!MDClassElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 00:56'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]! !

!MDClassElement methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:20'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassElement: self! !

!MDClassElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 00:56'!
hash
	^ theClassName hash! !

!MDClassElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:10'!
isIncludedInSlice: aSlice
	^ aSlice includesClass: self! !

!MDClassElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:04'!
printDebugIdOn: aStream
	aStream nextPutAll: theClassName! !

!MDClassElement methodsFor: 'initialize-release' stamp: 'cwp 2/5/2005 21:27'!
setClassName: aSymbol 
	theClassName := aSymbol! !

!MDClassElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 21:28'!
theClassName
	^ theClassName! !

MDImageElement subclass: #MDClassVarElement
	instanceVariableNames: 'theClassName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassVarElement class methodsFor: 'intance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol name: aString
	^ self basicNew setClassName: aSymbol name: aString! !

!MDClassVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:38'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]
		and: [self name = other name]! !

!MDClassVarElement methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:31'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassVarElement: self! !

!MDClassVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:39'!
hash
	^ theClassName hash bitXor: name hash! !

!MDClassVarElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:14'!
isIncludedInSlice: aSlice
	^ aSlice includesClassVar: self! !

!MDClassVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 13:52'!
name
	^ name! !

!MDClassVarElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:08'!
printDebugIdOn: aStream
	^ self printStdIdOn: aStream with: '%'! !

!MDClassVarElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 13:48'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

!MDClassVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 13:52'!
theClassName
	^ theClassName! !

MDImageElement subclass: #MDFakeElement
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElement class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 19:02'!
named: aSymbol
	^ self new name: aSymbol! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
= other
	self species = other species ifFalse: [^ false].
	^ self name = other name! !

!MDFakeElement methodsFor: 'public' stamp: 'cwp 2/5/2005 19:03'!
adaptedFor: anImageProxy 
	^ anImageProxy adaptorForElement: self! !

!MDFakeElement methodsFor: 'printing' stamp: 'cwp 4/25/2005 04:11'!
displayOn: aStream
	aStream nextPutAll: name! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
hash
	^ name hash! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name
	^ name! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name: aSymbol
	name _ aSymbol! !

!MDFakeElement methodsFor: 'printing' stamp: 'cwp 4/25/2005 04:10'!
printOn: aStream
	self printNameOn: aStream during: [aStream nextPutAll: name]! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'adapting' stamp: 'cwp 2/3/2005 23:54'!
adaptedFor: anImageProxy
	self subclassResponsibility! !

!MDImageElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:27'!
alwaysPreferDefinition
	^ false! !

!MDImageElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:27'!
alwaysPreferRemoval
	^ false! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 5/24/2005 07:43'!
display: properties for: anImageProxy
	^ (self adaptedFor: anImageProxy) display: properties! !

!MDImageElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:43'!
displayClassName
	^ 'Element'! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
is: properties upToDateFor: anImageProxy
	^ (self adaptedFor: anImageProxy) isUpToDate: properties! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:42'!
isLoadable: properties into: anImageProxy
	^ (self adaptedFor: anImageProxy) isLoadable: properties
! !

!MDImageElement methodsFor: 'testing' stamp: 'cwp 3/27/2005 22:26'!
isMeta
	^ false! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
load: properties into: anImageProxy
	^ (self adaptedFor: anImageProxy) load: properties
! !

!MDImageElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:22'!
merge: aPropertyDictionary into: otherPropertyDictionary in: anImageProxy onFailure: aBlock
	^ (self adaptedFor: anImageProxy)
		merge: aPropertyDictionary
		into: otherPropertyDictionary
		onFailure: aBlock! !

!MDImageElement methodsFor: 'printing' stamp: 'cwp 8/20/2005 18:51'!
printDebugIdOn: aStream
	aStream print: self identityHash! !

!MDImageElement methodsFor: 'printing' stamp: 'cwp 9/3/2005 22:46'!
printOn: aStream
	aStream nextPut: $<.
	self printDebugIdOn: aStream.
	aStream nextPut: $>! !

!MDImageElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:07'!
printStdIdOn: aStream with: aString
	aStream
		nextPutAll: self theClassName;
		nextPutAll: aString;
		nextPutAll: self name! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
removeFrom: anImageProxy
	^ (self adaptedFor: anImageProxy) remove! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
update: properties from: anImageProxy
	^ (self adaptedFor: anImageProxy) update: properties! !

MDImageElement subclass: #MDInstVarElement
	instanceVariableNames: 'theClassName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDInstVarElement subclass: #MDClassInstVarElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassInstVarElement methodsFor: 'as yet unclassified' stamp: 'cwp 3/4/2005 14:48'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassInstVarElement: self! !

!MDClassInstVarElement methodsFor: 'as yet unclassified' stamp: 'cwp 8/29/2005 01:17'!
isIncludedInSlice: aSlice
	^ aSlice includesClassInstVar: self! !

!MDClassInstVarElement methodsFor: 'as yet unclassified' stamp: 'cwp 8/28/2005 17:12'!
printDebugIdOn: aStream
	self printStdIdOn: aStream with: '$'! !

!MDInstVarElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:18'!
className: aSymbol name: aString
	^ self basicNew setClassName: aSymbol name: aString! !

!MDInstVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:32'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]
		and: [self name = other name]! !

!MDInstVarElement methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:28'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForInstVarElement: self! !

!MDInstVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:32'!
hash
	^ theClassName hash bitXor: name hash! !

!MDInstVarElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:15'!
isIncludedInSlice: aSlice
	^ aSlice includesInstVar: self! !

!MDInstVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:52'!
name
	^ name! !

!MDInstVarElement methodsFor: 'printing' stamp: 'cwp 8/27/2005 12:47'!
printDebugIdOn: aStream
	aStream
		nextPutAll: theClassName;
		nextPut: $@;
		nextPutAll: name! !

!MDInstVarElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 12:27'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

!MDInstVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:49'!
theClassName
	^ theClassName! !

MDImageElement subclass: #MDMethodElement
	instanceVariableNames: 'theClassName selector classIsMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aString selector: aSymbol 
	^self className: aString selector: aSymbol classIsMeta: false! !

!MDMethodElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:16'!
className: aString selector: aSymbol classIsMeta: aBoolean
	^self basicNew setClassName: aString selector: aSymbol classIsMeta: aBoolean! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:08'!
= other 
	^ (self species = other species) 
		and: [self theClassName = other theClassName]
		and: [self selector = other selector]! !

!MDMethodElement methodsFor: 'adapting' stamp: 'cwp 2/3/2005 22:09'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForMethodElement: self! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:25'!
classIsMeta
	^ classIsMeta! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 21:22'!
hash
	^(theClassName , '|' , selector) hash! !

!MDMethodElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:18'!
isIncludedInSlice: aSlice
	^ aSlice includesMethod: self! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 8/28/2005 17:15'!
name
	^ selector! !

!MDMethodElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:14'!
printDebugIdOn: aStream
	self
		printStdIdOn: aStream
		with: (classIsMeta 
				ifTrue: ['*']
				ifFalse: ['#'])
	! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'cwp 2/12/2005 15:15'!
setClassName: aString selector: aSymbol classIsMeta: aBoolean
	theClassName := aString.
	selector := aSymbol.
	classIsMeta := aBoolean! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 21:22'!
theClassName
	^theClassName! !

MDImageElement subclass: #MDPoolImportElement
	instanceVariableNames: 'theClassName poolName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPoolImportElement class methodsFor: 'instance creation' stamp: 'cwp 4/2/2005 23:49'!
className: aSymbol name: aString
	^ self className: aSymbol poolName: aString! !

!MDPoolImportElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:18'!
className: classNameSymbol poolName: poolNameSymbol
	^ self basicNew setClassName: classNameSymbol poolName: poolNameSymbol! !

!MDPoolImportElement methodsFor: 'comparing' stamp: 'cwp 8/21/2005 11:53'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]
		and: [self poolName = other poolName]! !

!MDPoolImportElement methodsFor: 'converting' stamp: 'cwp 2/7/2005 00:01'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForPoolImportElement: self! !

!MDPoolImportElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:57'!
hash
	^ theClassName hash bitXor: poolName hash! !

!MDPoolImportElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:31'!
isIncludedInSlice: aSlice 
	^ aSlice includesPoolImport: self! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 8/28/2005 17:18'!
name
	^ poolName! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 23:36'!
poolName
	^ poolName! !

!MDPoolImportElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:20'!
printDebugIdOn: aStream
	self printStdIdOn: aStream with: '&'! !

!MDPoolImportElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 23:13'!
setClassName: classNameSymbol poolName: poolNameSymbol
	theClassName := classNameSymbol.
	poolName := poolNameSymbol! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 23:36'!
theClassName
	^ theClassName! !

MDImageElement subclass: #MDSliceElement
	instanceVariableNames: 'definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDSliceElement subclass: #MDLogElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDLogElement methodsFor: 'adapting' stamp: 'cwp 3/22/2005 23:10'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForLogElement: self! !

MDSliceElement subclass: #MDMetadataElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMetadataElement methodsFor: 'adapting' stamp: 'cwp 3/22/2005 23:12'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForMetadataElement: self! !

!MDSliceElement class methodsFor: 'as yet unclassified' stamp: 'cwp 12/29/2006 17:47'!
forSlice: aSlice
	^ self basicNew setDefinition: aSlice definition! !

!MDSliceElement methodsFor: 'comparing' stamp: 'cwp 12/29/2006 17:40'!
= other
	^ self species = other species 
		and: [definition = other definition]
		! !

!MDSliceElement methodsFor: 'accessing' stamp: 'cwp 12/29/2006 17:42'!
definition
	^ definition! !

!MDSliceElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:44'!
displayClassName
	^ self className allButFirst: 2! !

!MDSliceElement methodsFor: 'comparing' stamp: 'cwp 12/29/2006 17:43'!
hash
	^ definition hash! !

!MDSliceElement methodsFor: 'testing' stamp: 'cwp 3/27/2005 22:26'!
isMeta
	^ true! !

!MDSliceElement methodsFor: 'printing' stamp: 'cwp 12/29/2006 17:44'!
printDebugIdOn: aStream
	self sliceType = 'Package' ifFalse:
		[aStream
			nextPutAll: self sliceType;
			nextPut: $-].
	aStream nextPutAll: self sliceName! !

!MDSliceElement methodsFor: 'initialize-release' stamp: 'cwp 12/29/2006 17:48'!
setDefinition: aPropertyDictionary
	definition _ aPropertyDictionary! !

!MDSliceElement methodsFor: 'initialize-release' stamp: 'cwp 12/29/2006 17:33'!
setName: aString type: aSymbol
	definition _ MDPropertyDictionary new.
	definition 
		name: aString;
		type: aSymbol
! !

!MDSliceElement methodsFor: 'accessing' stamp: 'cwp 12/29/2006 17:33'!
sliceName
	^ definition name! !

!MDSliceElement methodsFor: 'accessing' stamp: 'cwp 12/29/2006 17:34'!
sliceType
	^ definition type! !

Object subclass: #MDImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageProxy commentStamp: 'cwp 5/7/2006 23:10' prior: 0!
I am an abstract superclass. I present an interface to a Smalltalk image. I have methods for querying the state of elements in the image and modifying them. My protocol is expressed in terms of Elements and Variants; I know nothing about Versions.

My subclasses must implement an adaption method for each subclass of ImageElement.!

MDImageProxy subclass: #MDFakeImageProxy
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/12/2005 14:04'!
adaptorForClassCommentElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:18'!
adaptorForClassElement: aClassElement 
	^ self adaptorForElement: aClassElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 3/4/2005 14:46'!
adaptorForClassInstVarElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:29'!
adaptorForClassVarElement: anClassVarElement
	^ self adaptorForElement: anClassVarElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForElement: anElement 
	^ MDFakeElementAdaptor
		forElement: anElement
		inImage: dict! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:29'!
adaptorForInstVarElement: anInstVarElement
	^ self adaptorForElement: anInstVarElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 3/15/2005 22:36'!
adaptorForLogElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 3/22/2005 23:13'!
adaptorForMetadataElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForMethodElement: aMethodElement 
	^ self adaptorForElement: aMethodElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/7/2005 00:01'!
adaptorForPoolImportElement: aPoolImportElement 
	^ self adaptorForElement: aPoolImportElement! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/5/2005 16:08'!
at: anElement
	^ dict at: anElement ifAbsentPut: [Dictionary new]
! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:28'!
includesKey: anElement 
	^ dict includesKey: anElement! !

!MDFakeImageProxy methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:23'!
initialize
	dict _ Dictionary new! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:23'!
removeKey: anElement
	dict removeKey: anElement! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/4/2006 20:40'!
display: aVariant 
	^aVariant displayFor: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/3/2005 23:56'!
hasElement: anElement
	^ (anElement adaptedFor: self) isPresent! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/4/2006 20:40'!
isLoadable: aVariant 
	^aVariant isLoadableInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/4/2006 20:41'!
isUpToDate: aVariant 
	^aVariant isUpToDateFor: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 10/16/2005 14:16'!
loadVariant: aVariant 
	aVariant loadInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 3/2/2006 18:25'!
transaction: aBlock
	^ aBlock value! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 10/16/2005 14:17'!
updateVariant: aVariant 
	^aVariant updateFrom: self! !

Object subclass: #MDKeyedStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDKeyedStream class methodsFor: 'as yet unclassified' stamp: 'avi 4/17/2005 01:19'!
on: aStream
	^ self basicNew initializeWithStream: aStream! !

!MDKeyedStream methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
= other
	^ self species = other species
		and: [self stream name = other stream name]! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:18'!
appendKey: keyBytes value: valueBytes 
	self assert: [keyBytes size = self keySize].
	stream
		position: stream size;
		nextPutAll: keyBytes;
		nextInt32Put: valueBytes size;
		nextPutAll: valueBytes! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 10/13/2005 23:00'!
close
	stream name = 'a stream' ifFalse: [stream close]! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:58'!
flush
	stream flush! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/19/2005 01:49'!
fromPosition: aNumber keysValuesAndPositionsDo: aBlock 
	| position key |
	stream position: aNumber.
	[stream atEnd] whileFalse: 
			[key := stream next: self keySize.
			position := stream position.
			aBlock
				value: key
				value: self readValue
				value: position]! !

!MDKeyedStream methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
hash
	^ self stream name hash! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'avi 4/17/2005 01:19'!
initializeWithStream: aPositionableStream
	stream _ aPositionableStream.
	stream binary! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 15:14'!
keySize
	^ 24! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 02:11'!
keysValuesAndPositionsDo: aBlock 
	self fromPosition: 0 keysValuesAndPositionsDo: aBlock
			! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:38'!
nextValuePosition
	^ stream size + self keySize! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 4/10/2005 17:29'!
position
	^ stream position! !

!MDKeyedStream methodsFor: 'private' stamp: 'avi 4/17/2005 01:29'!
readValue
	| length |
	length := stream nextInt32.
	^ stream next: length.
	! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'avi 3/22/2006 19:23'!
reopen
	stream name = 'a stream' ifFalse: [stream reopen; binary]! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 14:53'!
stream
	^ stream! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:28'!
valueAtPosition: anInteger
	stream position: anInteger.
	^ self readValue! !

Object subclass: #MDMarshal
	instanceVariableNames: 'stream'
	classVariableNames: 'ClassMap InverseClassMap'
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDMarshal commentStamp: 'cwp 3/9/2005 22:40' prior: 0!
I am used to serialize versioning objects - Elements, ElementDefinitions, ElementRemovals, ElementVersions and Snapshots - both for persistence and hashing. My serialization scheme is remeniscent of that used by DataStream, but it has the following differences:

Rather than type codes, I use class ids. This is because I don't have to be able to handle any object, but only those classes mentioned above. I encode class ids as a single byte, but only 22 classes are used so far, so there is room to add more if need be. 

Also, I'm more verbose than a ReferenceStream, but this is unavoidable, since I must always produce a canonical serialization of any object in the tree, not just one that can reproduce the original root object. 

Finally, I'm less flexible than DataStream, since I provide no hooks to allow objects to customize how they are serialized. I use double dispatch to find appropriate encoding and decoding methods for objects.
!

!MDMarshal class methodsFor: 'public' stamp: 'avi 4/19/2005 01:46'!
classFor: aByteArray
	^ self classFromId: aByteArray first! !

!MDMarshal class methodsFor: 'class ids' stamp: 'cwp 3/7/2005 16:10'!
classFromId: anInteger
	^ ClassMap at: anInteger! !

!MDMarshal class methodsFor: 'class ids' stamp: 'cwp 3/11/2005 23:23'!
classIdForObject: anObject 
	^ InverseClassMap
		at: anObject class
		ifAbsent: [self error: 'Unrecognized object class']! !

!MDMarshal class methodsFor: 'initialize-release' stamp: 'cwp 3/20/2005 01:16'!
initialize
	ClassMap := MDPlatform current serializationClassMap.
	InverseClassMap := Dictionary new.
	ClassMap withIndexDo: [:ea :i | InverseClassMap at: ea put: i]! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 3/9/2005 00:00'!
materialize: aByteArray
	^ self materializeFrom: aByteArray readStream! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 6/18/2005 16:04'!
materializeFrom: aWriteStram
	| instance |
	instance := self on: aWriteStram.
	^ instance materialize! !

!MDMarshal class methodsFor: 'instance creation' stamp: 'cwp 3/7/2005 21:35'!
on: aStream
	^ self new setStream: aStream! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 3/8/2005 23:59'!
serialize: anObject
	| byteStream |
	byteStream _ (ByteArray new: 100) writeStream.
	self serialize: anObject on: byteStream.
	^ byteStream contents
! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 6/18/2005 16:04'!
serialize: anObject on: aWriteStream
	|  instance |
	instance := self on: aWriteStream.
	instance serialize: anObject.
	^ aWriteStream contents! !

!MDMarshal methodsFor: 'private' stamp: 'cwp 3/7/2005 21:53'!
classFromId: anInteger
	^ ClassMap at: anInteger! !

!MDMarshal methodsFor: 'private' stamp: 'avi 3/12/2005 04:08'!
classIdOfObject: anObject
	^ self class classIdForObject: anObject! !

!MDMarshal methodsFor: 'public' stamp: 'cwp 3/9/2005 20:51'!
materialize
	| class |
	class _ MDMarshal classFromId: stream next.
	^ class materializeWith: self! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:52'!
readBooleanOfClass: aClass
	^ aClass initializedInstance! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 4/18/2005 13:40'!
readBytes: aByteObject
	1 to: aByteObject size do: [:i | aByteObject byteAt: i put: stream next].
	^ aByteObject! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:59'!
readDictionaryOfClass: aClass
	| size dictionary |
	size _ stream next.
	dictionary _ aClass new: size.
	size timesRepeat:
		[dictionary 
			at: self materialize 
			put: self materialize].
	^ dictionary
! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 8/9/2005 21:20'!
readHashedObject: anObject
	self readObject: anObject.
	anObject initHashstamp.
	^ anObject! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:00'!
readObject: anObject
	1
		to: anObject class instSize 
		do: [:i | anObject instVarAt: i put: (self materialize)].
	^ anObject! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:15'!
readSetOfClass: aClass
	| size set |
	size _ self readSmallInteger.
	set _ aClass new: size.
	size timesRepeat: [set add: self materialize].
	^ set! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:04'!
readSmallInteger
	| integer |
	integer _ stream next bitShift: 24.
	integer _ integer bitOr: (stream next bitShift: 16).
	integer _ integer bitOr: (stream next bitShift: 8).
	^ integer bitOr: stream next! !

!MDMarshal methodsFor: 'reading' stamp: 'avi 3/20/2006 00:18'!
readStringOfClass: aClass
	| size bytes |
	size _ (stream next bitShift: 8) bitOr: stream next.
	bytes _ stream next: size.
	^ aClass name = #String ifTrue: [bytes asString] ifFalse: [aClass fromByteArray: bytes]! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 20:57'!
readSymbol
	^ (self readStringOfClass: String) asSymbol! !

!MDMarshal methodsFor: 'public' stamp: 'cwp 3/9/2005 20:37'!
serialize: anObject
	stream nextPut: (self classIdOfObject: anObject).
	anObject serializeWith: self! !

!MDMarshal methodsFor: 'initialize-release' stamp: 'cwp 3/7/2005 21:34'!
setStream: aStream
	stream _ aStream! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 21:49'!
writeBoolean: aBoolean! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 4/18/2005 13:44'!
writeBytes: aByteObject
	1 to: aByteObject byteSize do: [:i | stream nextPut: (aByteObject byteAt: i)]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:44'!
writeDictionary: aDictionary
	stream nextPut: aDictionary size.
	aDictionary keysAndValuesDo:
		[:key :value |
		self serialize: key.
		self serialize: value]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 8/9/2005 21:16'!
writeHashedObject: anObject
	self serialize: anObject timestamp.
	2 to: anObject class instSize do: [:i | self serialize: (anObject instVarAt: i)]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:18'!
writeObject: anObject
	1 to: anObject class instSize do: [:i | self serialize: (anObject instVarAt: i)]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:39'!
writeSet: aSet
	self writeSmallInteger: aSet size.
	aSet do: [:ea | self serialize: ea]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 23:51'!
writeSmallInteger: aSmallInteger
	stream 
		nextPut: (aSmallInteger bitShift: -24);
		nextPut: ((aSmallInteger bitShift: -16) bitAnd: 16rFF);
		nextPut: ((aSmallInteger bitShift: -8) bitAnd: 16rFF);
		nextPut: (aSmallInteger bitAnd: 16rFF)! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:12'!
writeString: aString
	aString size > 16rFFFF ifTrue: [aString error: 'String too long to serialize'].
	stream
		nextPut: (aString byteSize bitShift: -8);
		nextPut: (aString byteSize bitAnd: 16rFF).
	1 to: aString byteSize do: [:i | stream nextPut: (aString byteAt: i)]! !

Object subclass: #MDMerge
	instanceVariableNames: 'local remote resolution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDMerge class methodsFor: 'instance creation' stamp: 'cwp 3/2/2006 15:15'!
toInclude: aVersion in: aWorkingCopy 
	| local |
	local _ aWorkingCopy versionForElement: aVersion element.
	^ self basicNew setLocal: local remote: aVersion.
! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 3/2/2006 14:57'!
applyTo: aWorkingCopy
	aWorkingCopy includeVersion: resolution onConflict: [:l :r | r variant]! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 3/17/2005 23:27'!
chooseLocal
	resolution _ local! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 3/17/2005 23:29'!
chooseRemote
	resolution _ remote! !

!MDMerge methodsFor: 'printing' stamp: 'cwp 4/25/2005 04:02'!
displayOn: aStream
	self remote element displayOn: aStream! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:21'!
isConflict
	^ remote conflictsWith: local! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:16'!
isLocal
	^ resolution == local! !

!MDMerge methodsFor: 'testing' stamp: 'avi 3/21/2006 00:14'!
isNoOp
	^ local = remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:19'!
isRemote
	^ resolution == remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 6/9/2005 09:01'!
isResolved
	^ resolution notNil! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
local
	^ local! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
remote
	^ remote! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
resolution
	^ resolution! !

!MDMerge methodsFor: 'initialize-release' stamp: 'cwp 3/2/2006 15:13'!
setLocal: localVersion remote: remoteVersion
	local _ localVersion.
	remote _ remoteVersion.
	resolution _ local successor: remote! !

Object subclass: #MDRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

MDRepository subclass: #MDFileRepository
	instanceVariableNames: 'dataStream index snapshotHashstamps lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDFileRepository class methodsFor: 'accessing' stamp: 'cwp 10/12/2005 21:30'!
extension
	^ '.mcr'! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'cwp 2/2/2006 22:20'!
named: aString
	^ self on: (FileStream fileNamed: aString, self extension)! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'avi 4/17/2005 01:20'!
on: aFileStream
	^ self basicNew initializeWithStream: aFileStream! !

!MDFileRepository class methodsFor: 'saving' stamp: 'cwp 10/16/2005 12:37'!
saveSlice: aSlice as: aString
	| repo |
	repo := MDFileRepository named: aString.
	aSlice saveFrom: MDWorkingCopy default to: repo.
	repo close! !

!MDFileRepository methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:22'!
= other
	^ self species = other species
		and: [other dataStreamIs: dataStream]! !

!MDFileRepository methodsFor: 'initialize-release' stamp: 'cwp 10/13/2005 23:01'!
close
	dataStream close! !

!MDFileRepository methodsFor: 'private' stamp: 'cwp 12/25/2006 15:23'!
dataStreamIs: aStream
	^ dataStream = aStream! !

!MDFileRepository methodsFor: 'public' stamp: 'avi 3/20/2006 00:13'!
description
	^ dataStream stream localName! !

!MDFileRepository methodsFor: 'public' stamp: 'avi 4/19/2005 01:50'!
get: aHashstamp 
	| key bytes position |
	key := aHashstamp bytes.
	position := index at: key ifAbsent: [^self rescanData ifTrue: [self get: aHashstamp]].
	bytes := dataStream valueAtPosition: position.
	^MDMarshal materialize: bytes! !

!MDFileRepository methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
hash
	^ dataStream hash! !

!MDFileRepository methodsFor: 'initialize-release' stamp: 'avi 4/19/2005 01:50'!
initializeWithStream: aFileStream
	dataStream _ MDKeyedStream on: aFileStream.
	lastPosition _ 0.
	index _ Dictionary new.
	snapshotHashstamps _ Set new.
	self rescanData! !

!MDFileRepository methodsFor: 'public' stamp: 'avi 4/17/2005 01:58'!
put: aHashedObject
	| key value |
	key _ aHashedObject hashstamp bytes.
	index at: key ifAbsent:
		[value _ MDMarshal serialize: aHashedObject.
		index at: key put: dataStream nextValuePosition.
		dataStream appendKey: key value: value.
		dataStream flush]! !

!MDFileRepository methodsFor: 'private' stamp: 'avi 4/19/2005 01:50'!
rescanData
	dataStream reopen.
	dataStream fromPosition: lastPosition keysValuesAndPositionsDo:  
		[:key :val :pos |
		index at: key put: pos.
		(MDMarshal classFor: val) = MDSnapshot ifTrue:
			[snapshotHashstamps add: (MDHashstamp fromBytes: key)]].
	dataStream position = lastPosition
		ifTrue: [^ false]
		ifFalse: [lastPosition _ dataStream position. ^ true]! !

!MDFileRepository methodsFor: 'public' stamp: 'avi 4/19/2005 01:50'!
snapshotHashstampsDo: aBlock
	self rescanData.
	snapshotHashstamps do: aBlock! !

MDRepository subclass: #MDMemoryRepository
	instanceVariableNames: 'versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 5/23/2006 20:16'!
get: aHashstamp
	^ versions at: aHashstamp ifAbsent: [nil]! !

!MDMemoryRepository methodsFor: 'initialize-release' stamp: 'cwp 2/21/2005 20:20'!
initialize
	versions _ Dictionary new.! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 3/10/2005 20:20'!
put: anElementVersion
	versions at: anElementVersion hashstamp put: anElementVersion! !

!MDMemoryRepository methodsFor: 'public' stamp: 'avi 4/17/2005 02:19'!
snapshotHashstampsDo: aBlock
	versions keysAndValuesDo:
		[:hashstamp :version |
		(version isKindOf: MDSnapshot)
			ifTrue: [aBlock value: hashstamp]]! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 8/7/2005 21:57'!
versions
	^ versions! !

!MDRepository methodsFor: 'as yet unclassified' stamp: 'cwp 12/29/2006 18:02'!
close
! !

!MDRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2005 18:07'!
snapshotsAndMetaDo: aBlock
	| snapshot meta |
	self snapshotHashstampsDo: 
		[:ea |
		snapshot := self get: ea.
		meta := snapshot meta collect: [:m | self get: m].
		aBlock value: snapshot value: meta]! !

Object subclass: #MDSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

MDSlice subclass: #MDExplicitSlice
	instanceVariableNames: 'name elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'cwp 3/15/2005 22:24'!
basedOn: aSlice
	^ self basicNew 
			setName: aSlice name 
			elements: aSlice elements! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'cwp 3/15/2005 22:25'!
named: aString
	^ self basicNew setName: aString! !

!MDExplicitSlice class methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:33'!
type
	^ #Explicit! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 18:54'!
addElement: anElement
	elements add: anElement! !

!MDExplicitSlice methodsFor: 'enumerating' stamp: 'cwp 3/22/2005 22:50'!
do: aBlock	
	aBlock value: (MDLogElement forSlice: self).
	elements do: aBlock.! !

!MDExplicitSlice methodsFor: 'testing' stamp: 'cwp 8/28/2005 23:34'!
includes: anElement
	^ elements includes: anElement! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:26'!
name
	^ name! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'cwp 12/29/2006 17:53'!
setName: aString
	^ self setName: aString elements: Set new! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'cwp 3/15/2005 22:24'!
setName: aString elements: aSet
	name _ aString.
	elements _ aSet! !

!MDSlice class methodsFor: 'as yet unclassified' stamp: 'cwp 3/15/2005 22:33'!
type
	self subclassResponsibility! !

!MDSlice methodsFor: 'comparing' stamp: 'cwp 12/30/2006 12:56'!
= other
	^ self definition = other definition! !

!MDSlice methodsFor: 'converting' stamp: 'cwp 3/14/2005 22:28'!
asExplicitSlice
	^ MDExplicitSlice basedOn: self! !

!MDSlice methodsFor: 'accessing' stamp: 'cwp 12/29/2006 17:49'!
definition
	^ MDPropertyDictionary new
		name: self name;
		type: self type;
		yourself! !

!MDSlice methodsFor: 'enumerating' stamp: 'cwp 2/27/2005 22:54'!
do: aBlock
	self subclassResponsibility! !

!MDSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 19:08'!
elements
	| result |
	result _ Set new.
	self do: [:ea | result add: ea].
	^ result! !

!MDSlice methodsFor: 'private' stamp: 'cwp 2/27/2005 21:31'!
expandVersions: versions
	| existingElements result |
	existingElements _ versions collect: [:ea | ea element]. 
	result _ versions copy.
	self do: [:el | (existingElements includes: el) 
					ifFalse: [result add: (MDNullVersion forElement: el)]].
	^ result! !

!MDSlice methodsFor: 'comparing' stamp: 'cwp 12/30/2006 12:56'!
hash
	^ self definition hash! !

!MDSlice methodsFor: 'public' stamp: 'cwp 3/13/2005 00:37'!
include: aSnapshot
	^ self include: aSnapshot from: MDStore default in: MDWorkingCopy default! !

!MDSlice methodsFor: 'public' stamp: 'cwp 3/25/2005 22:23'!
include: aSnapshot from: aRepository in: aWorkingCopy
	| versions |
	versions _ aSnapshot getVersionsFrom: aRepository.
	MDMergeRequest
		includeAll: (self expandVersions: versions)
		in: aWorkingCopy! !

!MDSlice methodsFor: 'public' stamp: 'cwp 3/13/2005 00:36'!
load: aSnapshot
	^ self load: aSnapshot from: MDStore default to: MDWorkingCopy default! !

!MDSlice methodsFor: 'public' stamp: 'cwp 3/2/2006 15:54'!
load: aSnapshot from: aRepository to: aWorkingCopy
	| expanded |
	self withCursor: Cursor read do: 
		[expanded _ self expandVersions: (aSnapshot getVersionsFrom: aRepository).
		aWorkingCopy transaction: 
			[expanded do: [:ea | aWorkingCopy loadVersion: ea]]]! !

!MDSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:32'!
name
	^ self subclassResponsibility! !

!MDSlice methodsFor: 'public' stamp: 'cwp 3/13/2005 00:35'!
save
	^ self saveFrom: MDWorkingCopy default to: MDStore default! !

!MDSlice methodsFor: 'public' stamp: 'cwp 9/4/2005 00:21'!
saveFrom: aWorkingCopy to: aRepository
	| versions snapshot |
	self 
		withCursor: Cursor write 
		do: [versions _ Set new.	
			self do: 
				[:ea | | version |
				version _ aWorkingCopy versionForElement: ea.
				aRepository put: version.
				versions add: version].
			snapshot _ MDSnapshot withVersions: versions.
			aRepository put: snapshot].
	^ snapshot! !

!MDSlice methodsFor: 'working copy' stamp: 'cwp 10/16/2005 13:18'!
saveFrom: aWorkingCopy toFileNamed: aString 
	MDFileRepository saveSlice: self as: aString! !

!MDSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:32'!
type
	^ self class type! !

!MDSlice methodsFor: 'private' stamp: 'cwp 9/4/2005 00:23'!
withCursor: aCursor do: aBlock
	ActiveHand showTemporaryCursor: aCursor.
	aBlock ensure: [ActiveHand showTemporaryCursor: nil]! !

Object subclass: #MDSliceOrganizer
	instanceVariableNames: 'map'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

MDSliceOrganizer class
	instanceVariableNames: 'default'!

!MDSliceOrganizer class methodsFor: 'default' stamp: 'cwp 12/30/2006 13:06'!
default
	^ default ifNil: [default _ self new]! !

!MDSliceOrganizer class methodsFor: 'default' stamp: 'cwp 12/30/2006 13:08'!
default: aSliceOrganizer
	default _ aSliceOrganizer! !

!MDSliceOrganizer class methodsFor: 'instance creation' stamp: 'cwp 12/30/2006 13:03'!
new
	^ self basicNew initialize! !

!MDSliceOrganizer class methodsFor: 'default' stamp: 'cwp 12/30/2006 13:08'!
resetDefault
	default _ nil! !

!MDSliceOrganizer methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 00:05'!
addSlice: aSlice
	map at: aSlice put: self defaultInfo! !

!MDSliceOrganizer methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 00:08'!
defaultInfo
	^ MDPropertyDictionary new
		author: Utilities authorInitials;
		ordinal: 1;
		yourself! !

!MDSliceOrganizer methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 00:09'!
infoFor: aSlice
	^ map 
		at: aSlice 
		ifAbsentPut: [self defaultInfo]! !

!MDSliceOrganizer methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 00:09'!
infoMatching: definition
	| slice |
	slice _ map keys 
		detect: [:ea | ea definition = definition]
		ifNone: [self addSliceForDefinition: definition].
	^ self infoFor: slice! !

!MDSliceOrganizer methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 00:07'!
initialize
	map _ Dictionary new! !

!MDSliceOrganizer methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 00:07'!
slices
	^ map keys! !

Object subclass: #MDStore
	instanceVariableNames: 'repositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

MDStore class
	instanceVariableNames: 'default'!

!MDStore class methodsFor: 'private' stamp: 'cwp 4/18/2005 12:29'!
createDefault
	| store |
	store _ self new.
	store addRepository: (MDFileRepository named: 'repository').
	^ store! !

!MDStore class methodsFor: 'accessing' stamp: 'cwp 3/13/2005 01:07'!
default
	^ default ifNil: [default _ self createDefault]! !

!MDStore class methodsFor: 'accessing' stamp: 'cwp 3/13/2005 01:11'!
resetDefault
	default _ nil! !

!MDStore methodsFor: 'accessing' stamp: 'cwp 3/13/2005 00:26'!
addRepository: aRepository
	repositories add: aRepository! !

!MDStore methodsFor: 'accessing' stamp: 'cwp 12/23/2006 20:59'!
ensureRepository: aRepository
	(repositories includes: aRepository)
		ifFalse: [repositories add: aRepository]! !

!MDStore methodsFor: 'repository' stamp: 'cwp 5/23/2006 20:17'!
get: aHashstamp
	repositories do: [:ea | (ea get: aHashstamp) ifNotNilDo: [:object | ^ object]].
	^ nil! !

!MDStore methodsFor: 'initialize-release' stamp: 'cwp 3/13/2005 00:25'!
initialize
	repositories _ OrderedCollection new! !

!MDStore methodsFor: 'repository' stamp: 'cwp 3/13/2005 00:26'!
put: anObject
	repositories do: [:ea | ea put: anObject]! !

!MDStore methodsFor: 'accessing' stamp: 'cwp 12/29/2006 16:58'!
removeRepository: aRepository
	repositories remove: aRepository! !

!MDStore methodsFor: 'accessing' stamp: 'cwp 8/7/2005 21:58'!
repositories
	^ repositories! !

!MDStore methodsFor: 'repository' stamp: 'avi 4/17/2005 02:18'!
snapshotHashstampsDo: aBlock
	repositories do: [:ea | ea snapshotHashstampsDo: aBlock]! !

Object subclass: #MDTimestampPrinter
	instanceVariableNames: 'year month day hours minutes seconds'
	classVariableNames: 'MonthNames Map'
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDTimestampPrinter commentStamp: 'cwp 4/9/2005 04:06' prior: 0!
%V - If the week containing 1 January has four or more days in the new year, then it is considered week 1. Otherwise, it is the last week of the previous year, and the next week is week 1.
%W - the week number of the year (Monday as the first day of the week) as a decimal number [00,53]. All days in a new year preceding the first Monday are considered to be in week 0.!

!MDTimestampPrinter class methodsFor: 'as yet unclassified' stamp: 'cwp 4/9/2005 04:15'!
initialize
	MonthNames _ #(January February March April May June 
					July August September Ocober November December).
	Map _ Dictionary new.
	Map
		at: $a put: #abbreviatedWeekdayName:;
		at: $A put: #fullWeekdayName:;
		at: $b put: #abbreviatedMonthName:;
		at: $B put: #fullMonthName:;
		at: $C put: #centuryNumber:;
		at: $d put: #paddedDay:;
		at: $D put: #usDate:;
		at: $e put: #unpaddedDay:;
		at: $h put: #unpaddedHour24;
		at: $H put: #paddedHour24:;
		at: $i put: #unpaddedHour12:;
		at: $I put: #paddedHour12:;
		at: $j put: #dayOfYear:;
		at: $l put: #unpaddedMonth:;
		at: $m put: #paddedMonth:;
		at: $M put: #paddedMinute:;
		at: $n put: #newline:;
		at: $p put: #ampm:;
		at: $S put: #paddedSecond:;
		at: $t put: #tab:;
		at: $u put: #weekDayMonday:;
		at: $U put: #weekNumberSunday:;
		at: $V put: #weekNumberMonday:;
		at: $w put: #weekDaySunday:;
		at: $W put: #weekNumberMonday2:;
		at: $y put: #yearShort:;
		at: $Y put: #yearLong:;
		at: $% put: #percent:! !

!MDTimestampPrinter class methodsFor: 'as yet unclassified' stamp: 'cwp 4/9/2005 03:03'!
year: year month: month day: day hours: hours minutes: minutes seconds: seconds
	^ self new
		year: year;
		month: month;
		day: day;
		hours: hours;
		minutes: minutes;
		seconds: seconds;
		yourself! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:22'!
ampm: aStream
	aStream nextPutAll: (hours > 12 ifFalse: ['am'] ifTrue: ['pm'])! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:07'!
day
	^day! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:07'!
day: anObject
	day := anObject! !

!MDTimestampPrinter methodsFor: 'errors' stamp: 'cwp 4/9/2005 03:43'!
doesNotUnderstand: aMessage
	(Map values includes: aMessage selector)
		ifTrue: [self error: 'Unimplemented specifier'].
	^ super doesNotUnderstand: aMessage! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:17'!
fullMonthName: aStream
	aStream nextPutAll: (MonthNames at: month)! !

!MDTimestampPrinter methodsFor: 'private' stamp: 'cwp 4/9/2005 04:19'!
hour12
	| int |
	int _ hours \\ 12.
	int = 0 ifTrue: [int _ 12].
	^ int! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
hours
	^hours! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
hours: anObject
	hours := anObject! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
minutes
	^minutes! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
minutes: anObject
	minutes := anObject! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
month
	^month! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
month: anObject
	month := anObject! !

!MDTimestampPrinter methodsFor: 'private' stamp: 'cwp 4/9/2005 03:52'!
pad: anInteger on: aStream
	anInteger < 10 ifTrue: [aStream nextPut: $0]! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:52'!
paddedDay: aStream
	self pad: day on: aStream.
	self unpaddedDay: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:19'!
paddedHour12: aStream
	| int |
	int _ self hour12.
	self pad: int on: aStream.
	int printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:58'!
paddedHour24: aStream
	self pad: hours on: aStream.
	hours printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:57'!
paddedMinute: aStream
	self pad: minutes on: aStream.
	minutes printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:51'!
paddedMonth: aStream
	self pad: month on: aStream.
	self unpaddedMonth: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:21'!
paddedSecond: aStream
	self pad: seconds on: aStream.
	seconds printOn: aStream! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 4/9/2005 03:08'!
printFormat: aString
	| stream |
	stream _ (String new: 10) writeStream.
	self printOn: stream format: aString.
	^ stream contents! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 4/9/2005 03:17'!
printOn: aStream format: aString
	| specification char |
	specification _ aString readStream.
	[specification atEnd]	 whileFalse: 
		[char _ specification next.
		char = $%
			ifTrue: [self printOn: aStream specifier: specification next]
			ifFalse: [aStream nextPut: char]]! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 4/9/2005 03:42'!
printOn: aStream specifier: aCharacter
	| selector |
	selector _ Map 
				at: aCharacter 
				ifAbsent: [self error: 'Unrecongized specifier: ', aCharacter].
	self perform: selector with: aStream! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:01'!
seconds
	^seconds! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:01'!
seconds: anObject
	seconds := anObject! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:52'!
unpaddedDay: aStream
	day printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:20'!
unpaddedHour12: aStream
	self hour12 printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:47'!
unpaddedMonth: aStream
	month printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:08'!
weekNumberMonday
	"From the Unix spec: 'If the week containing 1 January has four or more days
	in the new year, then it is considered week 1. Otherwise, it is the last week of
	the previous year, and the next week is week 1.'"

	self error: 'Unimplemented Specifier'! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:08'!
weekNumberMonday2
	"From the Unix spec: 'If the week containing 1 January has four or more days in the new year, 
	then it is considered week 1. Otherwise, it is the last week of the previous year, 
	and the next week is week 1.'"

	self error: 'Unimplemented Specifier'! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
year
	^year! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
year: anObject
	year := anObject! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:53'!
yearLong: aStream
	year printOn: aStream! !

Object subclass: #MDVariant
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDVariant subclass: #MDDefinitionVariant
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDDefinitionVariant class methodsFor: 'instance creation' stamp: 'cwp 11/28/2004 12:52'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDDefinitionVariant methodsFor: 'comparing' stamp: 'cwp 3/7/2005 17:22'!
= other
	^ self species = other species
		and: [self element = other element]
		and: [self properties = other properties]! !

!MDDefinitionVariant methodsFor: 'conflicts' stamp: 'cwp 10/16/2005 14:46'!
autoMergeWith: aVariant in: anImageProxy 
	^aVariant autoMergeWithDefinition: self in: anImageProxy! !

!MDDefinitionVariant methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:22'!
autoMergeWithDefinition: anElementDefinition in: anImageProxy
	| newDefinition |
	newDefinition _ self copy.
	element
		merge: anElementDefinition properties
		into: newDefinition properties
		in: anImageProxy
		onFailure: [^ nil].
	^ newDefinition! !

!MDDefinitionVariant methodsFor: 'conflicts' stamp: 'cwp 10/16/2005 14:45'!
autoMergeWithRemoval: aRemovalVariant in: anImageProxy 
	element alwaysPreferRemoval ifTrue: [^aRemovalVariant].
	element alwaysPreferDefinition ifTrue: [^self].
	^nil! !

!MDDefinitionVariant methodsFor: 'copying' stamp: 'avi 11/29/2004 14:16'!
copy
	| new |
	new _ self species forElement: element.
	properties keysAndValuesDo:
		[:k :v|
		new properties at: k put: v].
	^ new! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'cwp 5/24/2005 07:42'!
displayFor: anImageProxy
	^ self element display: properties for: anImageProxy! !

!MDDefinitionVariant methodsFor: 'initialize-release' stamp: 'cwp 11/29/2004 00:50'!
initializeWithElement: anElement
	element _ anElement.
	properties _ MDPropertyDictionary new! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:41'!
isLoadableInto: anImageProxy
	^ element isLoadable: properties into: anImageProxy! !

!MDDefinitionVariant methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ false! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'cwp 3/2/2005 23:44'!
isUpToDateFor: anImageProxy
	^ (anImageProxy hasElement: element)
		and: [element is: properties upToDateFor: anImageProxy]! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:54'!
loadInto: anImageProxy
	element load: properties into: anImageProxy! !

!MDDefinitionVariant methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'cwp 10/16/2005 13:45'!
updateFrom: anImageProxy
	(anImageProxy hasElement: element) ifFalse: [^ MDRemovalVariant forElement: element].
	element update: properties from: anImageProxy.
	^ self! !

MDVariant subclass: #MDRemovalVariant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDRemovalVariant class methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:23'!
forElement: anImageElement
	^ self basicNew initializeWithElement: anImageElement! !

!MDRemovalVariant methodsFor: 'comparing' stamp: 'cwp 3/7/2005 17:20'!
= other
	^ self species = other species and: [self element = other element]! !

!MDRemovalVariant methodsFor: 'conflicts' stamp: 'cwp 10/16/2005 14:47'!
autoMergeWith: aVariant in: anImageProxy 
	^aVariant autoMergeWithRemoval: self in: anImageProxy! !

!MDRemovalVariant methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:16'!
autoMergeWithDefinition: anElementDefinition in: anImageProxy
	^ anElementDefinition autoMergeWithRemoval: self in: anImageProxy! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'cwp 5/24/2005 07:44'!
displayFor: anImageProxy
	^ '-- removed --'! !

!MDRemovalVariant methodsFor: 'comparing' stamp: 'cwp 3/7/2005 17:21'!
hash
	^ element hash! !

!MDRemovalVariant methodsFor: 'initialize-release' stamp: 'avi 12/2/2004 01:23'!
initializeWithElement: anImageElement
	element _ anImageElement! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:52'!
isLoadableInto: anImageProxy
	"Removals are always loadable."
	
	^ true! !

!MDRemovalVariant methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ true! !

!MDRemovalVariant methodsFor: 'testing' stamp: 'avi 12/2/2004 01:56'!
isUpToDateFor: anImageProxy
	^ (anImageProxy hasElement: element) not! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'avi 12/2/2004 01:27'!
loadInto: anImageProxy
	element removeFrom: anImageProxy! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'cwp 10/16/2005 13:44'!
updateFrom: anImageProxy
	^ (MDDefinitionVariant forElement: element) updateFrom: anImageProxy! !

!MDVariant methodsFor: 'accessing' stamp: 'cwp 10/16/2005 14:43'!
element
	^ element! !

Object subclass: #MDWorkingCopy
	instanceVariableNames: 'proxy versions slush transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

MDWorkingCopy class
	instanceVariableNames: 'default'!

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'cwp 3/4/2005 15:32'!
default
	^ default ifNil: [default _ self forImageProxy: self defaultImageProxy]! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'cwp 3/4/2005 15:32'!
defaultImageProxy
	^ MDSqueakImageProxy new! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:56'!
forImageProxy: anImageProxy
	^ self basicNew initializeWithImageProxy: anImageProxy! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'cwp 3/11/2005 20:48'!
resetDefault
	default _ nil! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 10/16/2005 14:40'!
createVersionForElement: anElement 
	| variant version |
	(proxy hasElement: anElement) 
		ifFalse: [^MDNullVersion forElement: anElement].
	variant := (MDDefinitionVariant forElement: anElement) updateFrom: proxy.
	version := MDElementVersion variant: variant.
	versions at: anElement put: version.
	^version! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 10/16/2005 14:07'!
displayVersion: aVersion 
	^proxy display: aVersion variant! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 10/17/2005 08:31'!
ensureTransactionDuring: aBlock
	^ transaction
		ifNil: [self transaction: aBlock]
		ifNotNil: [aBlock value]! !

!MDWorkingCopy methodsFor: 'public' stamp: 'avi 3/16/2005 11:59'!
includeVersion: anElementVersion onConflict: twoArgBlock 
	| current successor |
	current := self versionForElement: anElementVersion element.
	successor := current 
					successor: anElementVersion 
					onConflict: [current resolveConflictWith: anElementVersion in: proxy using: twoArgBlock].
	successor == current ifTrue: [^ false].
	self loadVersion: successor.	
	^true! !

!MDWorkingCopy methodsFor: 'initialize-release' stamp: 'cwp 3/10/2005 22:12'!
initializeWithImageProxy: anImageProxy
	proxy _ anImageProxy.
	versions _ Dictionary new.
	slush _ Set new.! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 3/10/2005 22:14'!
loadSlush
	| loading |	
	[loading _ slush.
	slush _ self loadSlush: loading.
	loading size > slush size] whileTrue.
	! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 10/16/2005 14:20'!
loadSlush: loading 
	| unloadable |
	unloadable := Set new.
	loading do: 
			[:ea | 
			(proxy isLoadable: ea variant) 
				ifTrue: [proxy loadVariant: ea variant]
				ifFalse: [unloadable add: ea]].
	^unloadable! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 2/4/2006 20:45'!
loadVersion: anElementVersion

	self ensureTransactionDuring: 
		[versions at: anElementVersion element put: anElementVersion.
		transaction add: anElementVersion]
! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 10/16/2005 14:22'!
newVersionForElement: anImageElement 
	| oldVersion newVariant |
	oldVersion := versions at: anImageElement.
	newVariant := oldVersion variant copy.
	^versions at: anImageElement
		put: (MDElementVersion variant: (proxy updateVariant: newVariant)
				ancestry: oldVersion fullAncestry)! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 3/2/2006 19:29'!
transaction: aBlock
	| result |
	transaction _ OrderedCollection new.
	result _ aBlock value.
	slush _ transaction, slush.
	transaction _ nil.
	proxy transaction: [self loadSlush].
	^ result! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 10/17/2005 08:35'!
versionForElement: anImageElement
	| old |
	old _ versions 
			at: anImageElement 
			ifAbsent: [^ self createVersionForElement: anImageElement].
	^ (proxy isUpToDate: old variant)
		ifTrue: [old]
		ifFalse: [self newVersionForElement: anImageElement]! !

!Object class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:59'!
materializeWith: aMarshal
	^ aMarshal readObject: self basicNew! !

!Object methodsFor: '*monticello2' stamp: 'cwp 3/7/2005 21:23'!
classId
	^ MDMarshal classIdForObject: self! !

!Object methodsFor: '*monticello2' stamp: 'cwp 4/25/2005 04:11'!
printNameOn: aStream during: aBlock
	aStream print: self class.
	aStream nextPut: $<.
	aBlock value.
	aStream nextPut: $>! !

!Object methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:10'!
serializeWith: aMarshal
	aMarshal writeObject: self! !

TestCase subclass: #MDAdaptionTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAdaptionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 22:33'!
isAbstract
	^ self name = #MDAdaptionTest! !

!MDAdaptionTest methodsFor: 'constants' stamp: 'cwp 3/2/2006 17:48'!
adaptorSelectors
	^ #(isPresent isUpToDate: load: remove update: merge:into:onFailure: display:)! !

!MDAdaptionTest methodsFor: 'configuration' stamp: 'cwp 3/2/2006 17:32'!
proxyClass
	self subclassResponsibility! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 2/6/2005 22:37'!
setUp
	proxy := self proxyClass new! !

!MDAdaptionTest methodsFor: 'constructing' stamp: 'cwp 3/15/2005 22:22'!
slice
	^ MDExplicitSlice named: 'Foo'! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/12/2005 13:59'!
testClassComment
	self tryAdapting: (MDClassCommentElement className: #MDBogusA)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:26'!
testClassElement
	self tryAdapting: (MDClassElement className: #MDBogusA)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 14:43'!
testClassInstVarElement
	self tryAdapting: (MDClassInstVarElement className: #MDBogusA name: 'beth')! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:29'!
testClassVarElement
	self tryAdapting: (MDClassVarElement className: #MDBogusA name: 'Beta')! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:27'!
testInstVarElement
	self tryAdapting: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 3/22/2005 22:50'!
testLogElement
	self tryAdapting: (MDLogElement forSlice: self slice)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 3/22/2005 22:51'!
testMetadataElement
	self tryAdapting: (MDMetadataElement forSlice: self slice)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:26'!
testMethodElement
	self tryAdapting: (MDMethodElement className: #MDBogusA selector: #method1)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 23:59'!
testPoolImportElement
	self tryAdapting: (MDPoolImportElement className: #MDBogusA poolName: #MDBogusPoolB)! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 2/6/2005 22:26'!
tryAdapting: anElement
	| adaptor |
	adaptor := anElement adaptedFor: proxy.
	self adaptorSelectors do: [:ea | self assert: (adaptor respondsTo: ea)].! !

MDAdaptionTest subclass: #MDFakeAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFakeAdaptionTest methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:32'!
proxyClass
	^ MDFakeImageProxy! !

TestCase subclass: #MDByteIndexTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDByteIndexTest methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2005 04:01'!
storeAndRetrieveWithFileSize: aNumber
	|  file stream |
	stream _ RWBinaryOrTextStream on: ByteArray new.
	stream next: aNumber put: 0.
	stream reset.
 
	file _ MDByteIndex stream: stream keySize: 2 valueSize: 4.
	file at: 'aa' asByteArray put: 'abcd' asByteArray.
	file at: 'ab' asByteArray put: 'qxry' asByteArray.
	file at: 'xy' asByteArray put: '1234' asByteArray.
	self assert: file tally = 3.

	self assert: (file at: 'aa' asByteArray) = 'abcd' asByteArray.
	self assert: (file at: 'ab' asByteArray) = 'qxry' asByteArray.
	self assert: (file at: 'xy' asByteArray) = '1234' asByteArray.
	file at: 'ab' asByteArray put: '9876' asByteArray.
	self assert: (file at: 'ab' asByteArray) = '9876' asByteArray.
	self assert: file tally = 3! !

!MDByteIndexTest methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2005 03:58'!
testStoreAndRetrieve
	self storeAndRetrieveWithFileSize: 100.
	self storeAndRetrieveWithFileSize: 24.
	self should: [self storeAndRetrieveWithFileSize: 12] raise: Error! !

TestCase subclass: #MDHashstampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 4/18/2005 13:47'!
testCreation
	| hashstamp |
	hashstamp _ MDHashstamp hashIn: [:stream | stream nextPutAll: 'abc' asByteArray].
	self assert: hashstamp digest digitLength = 20.
	self assert: (MDTimestamp now asInteger - hashstamp timestamp asInteger) < 5.! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 05:02'!
testEqual
	| first second now |
	now _ MDTimestamp now.
	first _ MDHashstamp forObject: 'abc' timestamp: now.
	second _ MDHashstamp forObject: 'abc' timestamp: now.
	self assert: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 20:40'!
testHash
	| first second |
	first _ MDHashstamp hashIn: [:stream | stream nextPutAll: 'abc' asByteArray].
	second _ MDHashstamp hashIn: [:stream | stream nextPutAll: 'bcd' asByteArray].
	self deny: first hash = second hash.
	self deny: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:44'!
testLessThan
	| first second |
	first _ MDHashstamp fromString: 'bjrm0RTKT7KesZu0C1N9d0Dv+-Fez-No'.
	second _ MDHashstamp fromString: 'c0qD0lTwM3oFdWJn9yYiSxGZjuhr9NHe'.
	self assert: first <= second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 9/13/2005 09:02'!
testPrinting
	| hashstamp |
	hashstamp _ MDHashstamp 
					forObject: 'abc'
					timestamp: (MDTimestamp fromInteger: 30000).
	self assert: hashstamp printString = '++-pA51gCqIOiGslmLJhdpOyQLbyBCg+'! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 20:41'!
testRead
	| hashstamp |
	hashstamp _ MDHashstamp hashIn: [:stream | stream nextPutAll: 'abc' asByteArray].
	self assert: hashstamp = (MDHashstamp fromString: hashstamp asString)
! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 4/18/2005 13:47'!
testTimestamp
	| first second now then |
	now _ MDTimestamp now.
	then _ MDTimestamp fromInteger: (now asInteger - 1).
	first _ MDHashstamp forObject: 'abc' timestamp: then.
	second _ MDHashstamp forObject: 'abc' timestamp: now.
	self assert: first digest = second digest.
	self deny: first = second! !

TestCase subclass: #MDKeyedStreamTest
	instanceVariableNames: 'dataStream baseStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:24'!
append: aSmallInteger
	dataStream 
		appendKey: (self key: aSmallInteger)
		value: (self value: aSmallInteger).
! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:19'!
assert: bytes is: aSmallInteger
	self assert: bytes last = aSmallInteger! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:02'!
bytes: count containing: aSmallInteger
	| key |
	key _ ByteArray new: count.
	key at: key size put: aSmallInteger.
	^ key! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:02'!
key: aSmallInteger
	^ self bytes: dataStream keySize containing: aSmallInteger! !

!MDKeyedStreamTest methodsFor: 'running' stamp: 'avi 4/17/2005 01:19'!
setUp
	baseStream := RWBinaryOrTextStream on: (ByteArray new: 100).
	dataStream := MDKeyedStream on: baseStream! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 16:11'!
testAppend
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p |
		self assert: k is: 1.
		self assert: v is: 1.
		self assert: p >= 0]! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 16:18'!
testKeysValuePositions
	| index position |
	1 to: 3 do: [:i | self append: i].
	index _ 1.
	position _ -1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p |
		self assert: k is: index.
		self assert: v is: index.
		self assert: p > position.
		position _ p.
		index _ index + 1]! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'avi 4/17/2005 01:39'!
testPosition
	| position |
	position _ dataStream nextValuePosition.
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p | self assert: p = position].
! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 17:17'!
testValueAtPosition
	| position |
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p | position _ p].
	self assert: (dataStream valueAtPosition: position) is: 1! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:07'!
value: aSmallInteger
	^ self bytes: dataStream keySize * 2 containing: aSmallInteger! !

TestCase subclass: #MDPropertyDictionaryTest
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:28'!
setUp
	properties _ MDPropertyDictionary new.! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:32'!
testGetNil
	self assert: (properties at: #undefined) isNil! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:29'!
testImplicitGet
	properties at: #one put: 1.
	self assert: properties one = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:28'!
testImplicitPut
	properties one: 1.
	self assert: (properties at: #one) = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:30'!
testPutNil
	properties at: #undefined put: nil.
	self assert: properties isEmpty! !

TestCase subclass: #MDRepositoryTest
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDRepositoryTest subclass: #MDFileRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 4/3/2005 04:28'!
newRepository
	^ MDFileRepository named: self testFileName! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 2/2/2006 23:25'!
tearDown
	repository close.
	FileDirectory default deleteFileNamed: self testFileName! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'avi 4/19/2005 01:35'!
testConcurrentAppend
	| version repository2 get |
	repository2 _ self newRepository.
	version _ self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version.
	get _ repository2 get: version hashstamp.
	self assert: get notNil.
	self assert: get isEquivalentTo: version.
! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'avi 3/14/2005 12:48'!
testFileName
	^ 'test-file-repository'! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'avi 4/17/2005 01:41'!
testReopen
	| version |
	version _ self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version.
	repository _ self newRepository.
	self assert: (repository get: version hashstamp) isEquivalentTo: version.
! !

MDRepositoryTest subclass: #MDMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 02:39'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	^ anElementVersion == otherElementVersion! !

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:46'!
newRepository
	^ MDMemoryRepository new! !

!MDRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2005 00:46'!
isAbstract
	^ self name = #MDRepositoryTest! !

!MDRepositoryTest methodsFor: 'asserting' stamp: 'avi 3/12/2005 02:39'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	^ (MDMarshal serialize: anElementVersion) = (MDMarshal serialize: otherElementVersion)! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:45'!
newRepository
	self subclassResponsibility! !

!MDRepositoryTest methodsFor: 'running' stamp: 'cwp 3/13/2005 00:23'!
setUp
	repository _ self newRepository! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 3/23/2005 22:53'!
snapshot
	^ MDSnapshot withVersions: (Set with: self version)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/23/2006 20:14'!
testGetUnknownVersion
	| snapshot |
	snapshot _ self snapshot.
	self assert: (repository get: snapshot hashstamp) isNil! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'avi 4/17/2005 02:19'!
testSnapshotHashstamps
	| version snapshot snapshotStamps |
	version _ self version.
	snapshot _ self snapshot.

	repository put: version; put: snapshot.

	snapshotStamps _  Array streamContents:
						[:s | repository snapshotHashstampsDo: [:ea | s nextPut: ea]].

	self assert: (snapshotStamps includes: snapshot hashstamp).
	self deny: (snapshotStamps includes: version hashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 3/13/2005 00:24'!
testStoreSnapshot
	| snapshot |
	snapshot _ self snapshot.
	repository put: snapshot.
	self assert: (repository get: snapshot hashstamp) isEquivalentTo: snapshot! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 3/13/2005 00:24'!
testStoreVersion
	| version |
	version _ self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:39'!
version
	^ MDElementVersion 
		variant: (MDDefinitionVariant 
					forElement: (MDFakeElement 
									named: #Alpha))! !

MDRepositoryTest subclass: #MDStoreTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDStoreTest methodsFor: 'construction' stamp: 'cwp 3/13/2005 00:33'!
newRepository
	^ MDStore new
		addRepository: MDMemoryRepository new;
		addRepository: MDMemoryRepository new;
		yourself! !

!MDStoreTest methodsFor: 'tests' stamp: 'cwp 3/12/2005 22:56'!
testSingleton
	self assert: MDStore default == MDStore default! !

TestCase subclass: #MDSliceOrganizerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceOrganizerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 00:06'!
testDefaultInfo
	| organizer info |
	organizer _ MDSliceOrganizer new.
	info _ organizer defaultInfo.
	self assert: (info isKindOf: MDPropertyDictionary).
	self assert: info ordinal = 1.
	self assert: info branch isNil.
	self assert: info author = Utilities authorInitials ! !

!MDSliceOrganizerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/30/2006 13:05'!
testDefaultOrganizer
	self assert: MDSliceOrganizer default == MDSliceOrganizer default! !

!MDSliceOrganizerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/30/2006 13:03'!
testGetAllSlices
	| organizer slice |
	organizer _ MDSliceOrganizer new.
	slice _ MDExplicitSlice named: 'TestSlice'.
	organizer addSlice: slice.
	self assert: organizer slices size = 1.
	self assert: organizer slices anyOne == slice.! !

!MDSliceOrganizerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/30/2006 13:18'!
testResetDefault
	| tmp |
	[tmp _ MDSliceOrganizer default.
	MDSliceOrganizer resetDefault.
	self deny: tmp == MDSliceOrganizer default]
		ensure: [tmp ifNotNil: [MDSliceOrganizer default: tmp]]! !

!MDSliceOrganizerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 00:06'!
testSliceReceivesDefaultInfo
	| organizer slice info |
	organizer _ MDSliceOrganizer new.
	slice _ MDExplicitSlice named: 'Test Slice'.
	organizer addSlice: slice.
	info _ organizer infoFor: slice.
	self assert: info = organizer defaultInfo! !

TestCase subclass: #MDSliceTest
	instanceVariableNames: 'slice elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceTest commentStamp: 'cwp 8/29/2005 00:40' prior: 0!
This comment needs to be here, or #testComment won't pass.!

MDSliceTest subclass: #MDExplicitSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDExplicitSliceTest methodsFor: 'constucting' stamp: 'cwp 3/3/2006 10:47'!
createSlice
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (MDClassElement className: #MDBogusA);
		addElement: (MDClassElement className: #MDSliceTest);
		addElement: (MDClassCommentElement className: #MDSliceTest);
		addElement: (MDMethodElement className: #MDSliceTest selector: #classes);
		addElement: (MDMethodElement className: #MDSliceTest selector: #methods);
		addElement: (MDMethodElement className: #MDSliceTest selector: #bogusMethodA classIsMeta: true);
		addElement: (MDMethodElement className: #MDSliceTest selector: #bogusMethodB classIsMeta: true);
		addElement: (MDInstVarElement className: #MDBogusA name: 'one');
		addElement: (MDClassVarElement className: #MDBogusA name: 'Alpha');
		addElement: (MDClassInstVarElement className: #MDBogusA name: 'aleph');
		addElement: (MDPoolImportElement className: #MDBogusA poolName: 'MDBogusPoolA');
		addElement: (MDPoolImportElement className: #MDBogusA poolName: 'TextConstants');
		yourself! !

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
isAbstract
	^ self name = #MDSliceTest! !

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
shouldInheritSelectors
	^ true! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 8/29/2005 01:04'!
assertAll: labels includedAs: aBlock 
	| expected |
	expected := labels collect: aBlock.
	expected do: [:ea | self assert: (slice includes: ea)].
! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 3/3/2006 11:51'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels enumeratedAs: aBlock 
	| expected forbidden |
	expected := expectedLabels collect: aBlock.
	forbidden := forbiddenLabels collect: aBlock.
	elements _ slice elements.
	self assert: (elements includesAllOf: expected).
	self deny: (elements includesAnyOf: forbidden)! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 3/3/2006 11:28'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels includedAs: aBlock 
	| expected forbidden |
	expected := expectedLabels collect: aBlock.
	expected do: [:ea | self assert: (slice includes: ea)].

	forbidden := forbiddenLabels collect: aBlock.
	forbidden do: [:ea | self deny: (slice includes: ea)]! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 3/3/2006 11:19'!
denyAny: labels enumeratedAs: aBlock 
	| forbidden |
	forbidden := labels collect: aBlock.
	slice do: [:ea | self deny: (forbidden includes: ea)]
! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 3/3/2006 10:56'!
denyAny: labels includedAs: aBlock 
	| expected |
	expected := labels collect: aBlock.
	expected do: [:ea | self deny: (slice includes: ea)].
! !

!MDSliceTest methodsFor: 'running' stamp: 'cwp 3/16/2005 01:02'!
setUp
	slice := self createSlice.! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 13:29'!
testEnumeratedClassInstVars
	self 
		assertAllOf: #(aleph)
		butNoneOf: #(doesntexist)
		enumeratedAs: [:name | MDClassInstVarElement 
								className: #MDBogusA 
								name: name]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 13:31'!
testEnumeratedClassMethods
	self 
		assertAllOf: #(bogusMethodA bogusMethodB)
		butNoneOf: #(methodDoesntExist)
		enumeratedAs: [:sel | MDMethodElement 
							className: #MDSliceTest 
							selector: sel
							classIsMeta: true]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 13:32'!
testEnumeratedClassVars
	self 
		assertAllOf: #('Alpha')
		butNoneOf: #('DoesntExist')
		includedAs: [:name | MDClassVarElement 
							className: #MDBogusA 
							name: name]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 12:08'!
testEnumeratedClasses
	self
		assertAllOf: #(MDBogusA MDSliceTest)
		butNoneOf: #(MDClassDoesntExist)
		enumeratedAs: [:name | MDClassElement className: name].
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 13:33'!
testEnumeratedComments
	self 
		assertAllOf: #(MDSliceTest)
		butNoneOf: #()
		enumeratedAs: [:name | MDClassCommentElement className: name]! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 13:36'!
testEnumeratedInstVars
	self 
		assertAllOf: #('one')
		butNoneOf: #('doesntexist')
		enumeratedAs: [:name | MDInstVarElement 
								className: #MDBogusA 
								name: name]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 13:37'!
testEnumeratedMethods
	self 
		assertAllOf: #(classes methods)
		butNoneOf: #(methodDoesntExist)
		enumeratedAs: [:sel | MDMethodElement 
								className: #MDSliceTest 
								selector: sel]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 13:37'!
testEnumeratedPoolImports
	self 
		assertAllOf: #('MDBogusPoolA' 'TextConstants')
		butNoneOf: #('PoolDoesntExist')
		enumeratedAs: [:name | MDPoolImportElement 
								className: #MDBogusA 
								poolName: name]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 12:15'!
testIncludedClasses
	self
		assertAllOf: #(MDBogusA MDSliceTest)
		butNoneOf: #(MDClassDoesntExist)
		includedAs: [:name | MDClassElement className: name].
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 13:33'!
testIncludedComments
	self 
		assertAllOf: #(MDSliceTest)
		butNoneOf: #(MDBogusA Object)
		includedAs: [:name | MDClassCommentElement className: name]! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 10:53'!
testLog
	self assert: (slice elements select: [:ea | ea isKindOf: MDLogElement]) size = 1! !

TestCase subclass: #MDTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDTestCase subclass: #MDAncestryTest
	instanceVariableNames: 'parent child'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 23:15'!
null
	^ MDNullVersion forElement: self element! !

!MDAncestryTest methodsFor: 'running' stamp: 'cwp 3/2/2005 22:46'!
setUp
	parent := self version.
	child := self 
				updateVersion: parent
				property: #foo
				put: 'alpha2'! !

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:55'!
sibling
	^self 
		updateVersion: parent
		property: #bar
		put: 'bar'! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildConflictsWithParent
	self deny: (child conflictsWith: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testChildConflictsWithSibling
	self assert: (child conflictsWith: self sibling)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildPrecedesParent
	self deny: (child precedes: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:17'!
testChildPreceedsNull
	self deny: (child precedes: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testChildSucceedsNull
	self assert: (child succeeds: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildSucceedsParent
	self assert: (child succeeds: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testChildSuccessorNull
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testChildSuccessorParent
	self assert: (child successor: parent onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:07'!
testChildSuccessorSibling
	| result merged sibling |
	sibling := self sibling.
	merged := child successor: sibling
				onConflict: 
					[result := self definition.
					result properties at: #merged put: true.
					result].
	self assert: (merged succeeds: child).
	self assert: (merged succeeds: sibling).
	self assert: merged variant properties merged! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testNullPrecedesChild
	self assert: (self null precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testNullSucceedsChild
	self deny: (self null succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testNullSuccessorChild
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:46'!
testParentConflictsWithChild
	self deny: (parent conflictsWith: child).! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentPrecedesChild
	self assert: (parent precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentSucceedsChild
	self deny: (parent succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testParentSuccessorChild
	self assert: (parent successor: child onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:15'!
testSiblingConflictsWithChild
	self assert: (self sibling conflictsWith: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:59'!
testSiblingPreceedsChild
	self deny: (self sibling precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 00:00'!
testSiblingSucceedsChild
	self deny: (self sibling succeeds: child)! !

MDTestCase subclass: #MDProxyTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDProxyTest subclass: #MDImageProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:21'!
testCurrentDefinition
	| variant |
	self 
		atElement: self element
		property: #one
		put: 1.
	variant := self definition.
	proxy updateVariant: variant.
	self assert: (variant properties at: #one) = 1! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:21'!
testIsLoadable
	| variant |
	variant _ self definition.
	variant properties at: #one put: 1.
	self assert: (proxy isLoadable: variant)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:16'!
testLoadAndUpdate
	| original retrieved |
	original := self definition.
	(original properties)
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadVariant: original.
	retrieved := proxy updateVariant: self definition.
	self assert: original properties = retrieved properties! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:16'!
testLoadAndUpdateRemoval
	| original retrieved |
	original := self definition.
	(original properties)
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadVariant: original.
	retrieved := proxy updateVariant: self removal.
	self assert: retrieved properties = original properties! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:21'!
testLoadDefinition
	| variant |
	variant := self definition.
	(variant properties)
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadVariant: variant.
	self assert: (self atElement: self element property: #one) = 1.
	self assert: (self atElement: self element property: #two) = 2.
	self assert: (self atElement: self element property: #three) = 3! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:16'!
testLoadRemoveAndUpdate
	| original retrieved |
	original := self definition.
	(original properties)
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadVariant: original.
	proxy loadVariant: self removal.
	retrieved := proxy updateVariant: self definition.
	self assert: retrieved element = self element.
	self assert: retrieved isRemoval! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:22'!
testNotLoadable
	| variant |
	variant _ self definition: #'Alpha/Delta'.
	variant properties at: #one put: 1.
	self deny: (proxy isLoadable: variant)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:22'!
testRemoval
	| variant |
	self 
		atElement: self element
		property: #one
		put: '1'.
	variant := self removal.
	proxy loadVariant: variant.
	self assert: (self atElement: self element property: #one) isNil! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:22'!
testRemovalLoadable
	| variant |
	variant _ self removal: #'Alpha/Delta'.
	self assert: (proxy isLoadable: variant)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:22'!
testRemovalUpToDate
	| variant removal |
	variant := self definition.
	removal := self removal.
	variant properties one: '1'.
	proxy loadVariant: variant.
	self deny: (proxy isUpToDate: removal).
	proxy loadVariant: removal.
	self assert: (proxy isUpToDate: removal)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:24'!
testTransaction
	| variant |
	variant := self definition.
	variant properties at: #one put: 1.
	proxy transaction: [proxy loadVariant: variant].
	self assert: (self atElement: self element property: #one) = 1.! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:22'!
testUpToDate
	| variant |
	variant := self definition.
	variant properties source: 'one ^ 1'.
	proxy loadVariant: variant.
	self assert: (proxy isUpToDate: variant).
	self 
		atElement: self element
		property: #source
		put: 'one ^ 11'.
	self deny: (proxy isUpToDate: variant)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:22'!
testUpdateDoesntChangeElement
	| variant original |
	variant := self definition.
	original := variant element.
	proxy updateVariant: variant.
	self assert: variant element = original! !

MDProxyTest subclass: #MDMergeTest
	instanceVariableNames: 'wc merge local remote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMergeTest methodsFor: 'running' stamp: 'cwp 3/25/2005 22:26'!
local: localVersion remote: remoteVersion
	local := localVersion.
	wc loadVersion: local.
	remote := remoteVersion.
	merge := MDMerge toInclude: remote in: wc.
! !

!MDMergeTest methodsFor: 'running' stamp: 'cwp 3/25/2005 21:44'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 15:01'!
testApply
	self 
		local: (self versionWith: 'local')
		remote: (self versionWith: 'remote').
	merge chooseRemote.
	merge applyTo: wc.
	self assertElementHasValue: 'remote'! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:05'!
testChooseLocal
	self local: self version remote: self version.
	self assert: merge isConflict.
	merge chooseLocal.
	self assert: merge isLocal.
	self assert: merge resolution == local! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:06'!
testChooseRemote
	self local: self version remote: self version.
	self assert: merge isConflict.
	merge chooseRemote.
	self assert: merge isRemote.
	self assert: merge resolution == remote! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 5/26/2006 16:36'!
testIsConflict
	self local: self version remote: self version.
	self assert: merge isConflict.
	self assert: merge isLocal.
	self deny: merge isRemote.
! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:46'!
testIsLocal
	remote _ self version.
	local _ self updateVersion: remote property: #one put: 'alpha2'.
	self local: local remote: remote.
	self assert: merge isLocal.
	self deny: merge isRemote.
	self deny: merge isConflict.! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:46'!
testIsRemote
	local _ self version.
	remote _ self updateVersion: local property: #one put: 'alpha2'.
	self local: local remote: remote.
	self assert: merge isRemote.
	self deny: merge isLocal.
	self deny: merge isConflict.
! !

!MDProxyTest class methodsFor: 'testing' stamp: 'abc 2/13/2005 12:37'!
isAbstract
	^ self name = #MDProxyTest! !

!MDProxyTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:37'!
assertElement: elem property: prop hasValue: value
	self assert: (self atElement: (self element: elem) property: prop) = value! !

!MDProxyTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:52'!
assertElementHasDefaultValue: aSymbol
	self assertElement: aSymbol property: #one hasValue: aSymbol asLowercase! !

!MDProxyTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:46'!
assertElementHasValue: value
	self assert: (self atElement: self element property: #one) = value! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/27/2005 20:58'!
atElement: element property: property
	^ (proxy at: element) at: property ifAbsent: [nil]! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/4/2005 23:54'!
atElement: element property: property put: value
	"This will need to be overriden in tests that use a real image proxy."
	
	(proxy at: element) at: property put: value! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:16'!
atProperty: aSymbol
	^ self atElement: self element property: aSymbol! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:17'!
atProperty: aSymbol put: aValue
	self atElement: self element property: aSymbol put: aValue
! !

!MDProxyTest methodsFor: 'configuration' stamp: 'cwp 2/4/2005 23:58'!
proxyClass
	^ MDFakeImageProxy! !

!MDProxyTest methodsFor: 'running' stamp: 'avi 11/29/2004 12:49'!
setUp
	proxy _ self proxyClass new! !

MDProxyTest subclass: #MDSliceOpsTest
	instanceVariableNames: 'wc repository snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:26'!
addToBoth: aVersion
	snapshot add: aVersion.
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToRepository: aVersion
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToSnapshot: aVersion
	snapshot add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:28'!
prepare
	self prepare: 
		[self addToBoth: (self versionFor: #Alpha with: 'alpha').
		self addToBoth: (self versionFor: #Beta with: 'beta')].
! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/23/2005 22:58'!
prepare: aBlock
	| repositoryVersions |
	repository _ Set new.
	snapshot _ Set new.
	aBlock value.
	repositoryVersions _ repository.
	repository _ MDMemoryRepository new.
	repositoryVersions do: [:ea | repository put: ea].
	snapshot _ MDSnapshot withVersions: snapshot
	
	! !

!MDSliceOpsTest methodsFor: 'running' stamp: 'cwp 3/10/2005 23:26'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.
! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/16/2005 00:24'!
slice
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (self element: #Alpha);
		addElement: (self element: #Beta);
		yourself
	! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/14/2005 22:26'!
testAsExplicitSlice
	| original copy |
	original _ self slice.
	copy _ original asExplicitSlice.
	self assert: (copy isKindOf: MDExplicitSlice).
	self assert: copy elements = original elements! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 15:01'!
testIncludeSnapshot
	self prepare.
	[self slice include: snapshot from: repository in: wc]
		on: MDMergeRequest
		do: [:ex | ex merges do: [:ea | ea applyTo: wc]].
			
	self assertElementHasDefaultValue: #Alpha.
	self assertElementHasDefaultValue: #Beta.! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:49'!
testLoadEqualSnapshot
	self prepare.
	self slice load: snapshot from: repository to: wc.
	self assertElementHasDefaultValue: #Alpha.
	self assertElementHasDefaultValue: #Beta.
! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:50'!
testLoadLargerSnapshot
	| slice alpha beta |
	self prepare.
	alpha _ self element: #Alpha.
	beta _ self element: #Beta.
	slice _ MDExplicitSlice named: 'TestSlice'.
	slice addElement: alpha.
	slice load: snapshot from: repository to: wc.
	self assert: (self atElement: alpha property: #one) = 'alpha'.
	self assert: (self atElement: beta property: #one) = 'beta'.
	self assert: slice elements size = 2! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:52'!
testLoadSmallerSnapshot
	self prepare: [self addToBoth: (self versionFor: #Alpha with: 'alpha')].
	self slice load: snapshot from: repository to: wc.
	self assertElementHasDefaultValue: #Alpha.
	self assertElement: #Beta property: #one hasValue: nil
! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:55'!
testLoadWithDepenencies
	self prepare:
		[self addToBoth: (self versionFor: #Alpha).
		self addToBoth: (self versionFor: #Beta).
		self addToBoth: (self versionFor: #'Alpha/Delta' with: 'ad')].

	self slice load: snapshot from: repository to: wc.
	self
		assertElementHasDefaultValue: #Alpha;
		assertElementHasDefaultValue: #Beta;
		assertElement: #'Alpha/Delta' property: #one hasValue: 'ad'.! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:35'!
testSnapshot
	| slice versions |
	self prepare: [].
	slice _ self slice.
	snapshot _ slice saveFrom: wc to: repository.
	versions _ snapshot getVersionsFrom: repository.
	slice do: 
		[:element |
		self assert: (versions anySatisfy: [:version | version element = element])].
	self deny: (repository get: snapshot hashstamp) isNil! !

MDProxyTest subclass: #MDWorkingCopyTest
	instanceVariableNames: 'wc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDWorkingCopyTest methodsFor: 'asserting' stamp: 'cwp 3/2/2005 23:49'!
assertConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | ^ self].
	self assert: false! !

!MDWorkingCopyTest methodsFor: 'asserting' stamp: 'cwp 3/2/2005 23:49'!
assertNoConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | self assert: false. ^self]! !

!MDWorkingCopyTest methodsFor: 'running' stamp: 'avi 11/29/2004 12:52'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testIncludeAbsentVersion
	| version |
	version := self version.
	version variant properties one: 'bar'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #one) = 'bar'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testIncludeConflictingVersion
	| version newVersion newVersion2 |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
				updateVersion: version
				property: #source
				put: 'two'.
	newVersion2 := self 
				updateVersion: version
				property: #source
				put: 'three'.
	wc loadVersion: newVersion.
	self assertConflictIncluding: newVersion2! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testIncludeNewVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	wc loadVersion: version.
	newVersion := self 
				updateVersion: version
				property: #source
				put: 'two'.
	self assertNoConflictIncluding: newVersion.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testIncludeOldVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
				updateVersion: version
				property: #source
				put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testLoad
	| version |
	version := self version.
	version variant properties one: '1'.
	wc loadVersion: version.
	self assert: (self atProperty: #one) = '1'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testLoadAndSave
	| version |
	version := self version.
	version variant properties one: '1'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testLoadDeleteAndSave
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	wc loadVersion: version.
	proxy removeKey: version element.
	newVersion := wc versionForElement: version element.
	wc loadVersion: newVersion.
	self deny: (proxy includesKey: version element)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testLoadModifyAndSave
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion := wc versionForElement: version element.
	self deny: newVersion == version.
	self assert: (newVersion succeeds: version)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testLoadModifySaveAndSave
	| version newVersion newVersion2 |
	version := self version.
	version variant properties source: 'one'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion := wc versionForElement: version element.
	newVersion2 := wc versionForElement: version element.
	self assert: newVersion == newVersion2! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testLoadOldVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
				updateVersion: version
				property: #source
				put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	wc loadVersion: version.
	self assert: (self atProperty: #source) = 'one'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testModifyAndIncludeConflictingVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	wc loadVersion: version.
	newVersion := self 
				updateVersion: version
				property: #source
				put: 'two'.
	self atProperty: #source put: 'three'.
	self assertConflictIncluding: newVersion! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testResolveConflict
	| version newVersion newVersion2 mergedVersion |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
				updateVersion: version
				property: #source
				put: 'two'.
	newVersion2 := self 
				updateVersion: version
				property: #source
				put: 'three'.
	wc loadVersion: newVersion.
	wc includeVersion: newVersion2
		onConflict: 
			[:a :b | 
			self assert: a variant properties source = 'two'.
			b variant].
	self assert: (self atProperty: #source) = 'three'.
	mergedVersion := wc versionForElement: version element.
	self assert: mergedVersion variant = newVersion2 variant.
	self assert: (mergedVersion succeeds: newVersion).
	self assert: (mergedVersion succeeds: newVersion2)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:59'!
testSaveAbsentVersion
	| saved constructed |
	saved := wc versionForElement: self element.
	constructed := self versionFor: #Alpha.
	self assert: saved ancestry isEmpty.
	self assert: (constructed succeeds: saved)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testSaveFirstVersion
	| version |
	self 
		atElement: self element
		property: #one
		put: 'one'.
	version := wc versionForElement: self element.
	self assert: version ancestry isEmpty.
	self assert: version variant properties one = 'one'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 15:30'!
testSingleton
	self assert: MDWorkingCopy default == MDWorkingCopy default! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 10/17/2005 08:21'!
testTransaction
	| version |
	version := self version.
	version variant properties one: '1'.
	wc transaction: 
		[wc loadVersion: version.
		self deny: (proxy includesKey: version element)].
	self assert: (self atProperty: #one) = '1'! !

MDTestCase subclass: #MDSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/4/2005 17:39'!
assertEqualityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after = before]! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/8/2005 00:22'!
assertEqualityOf: anObject using: aBlock 
	| other buffer |
	buffer := MDMarshal serialize: anObject.
	other := MDMarshal materialize: buffer.
	aBlock value: anObject value: other! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:20'!
testClassCommentElement
	self assertEqualityOf: (MDClassCommentElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:20'!
testClassElement
	self assertEqualityOf: (MDClassElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:22'!
testClassInstVarElement
	self assertEqualityOf: (MDClassInstVarElement className: #MDBogusA name: 'beth')! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/9/2005 21:45'!
testClassMethodElement
	self assertEqualityOf: (MDMethodElement 
							className: #MDBogusA 
							selector: #one 
							classIsMeta: true)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:21'!
testClassVarElement
	self assertEqualityOf: (MDClassVarElement className: #MDBogusA name: 'Alpha')! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 17:21'!
testElementDefinition
	self assertEqualityOf: self definition! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 17:04'!
testElementRemoval
	self assertEqualityOf: self removal.! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 15:35'!
testFakeElement
	self assertEqualityOf: self element! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 20:41'!
testHashstamp
	self assertEqualityOf: (MDHashstamp hashIn: [:stream | stream nextPutAll: 'abc' asByteArray])! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:21'!
testInstVarElement
	self assertEqualityOf: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/22/2005 23:53'!
testLogElement
	self assertEqualityOf: (MDLogElement forSlice: (MDExplicitSlice named: 'TestSlice'))! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:45'!
testLongString
	| string |
	string _ String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/22/2005 23:54'!
testMetadataElement
	self assertEqualityOf: (MDMetadataElement forSlice: (MDExplicitSlice named: 'TestSlice'))! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:23'!
testMethodElement
	self assertEqualityOf: (MDMethodElement className: #MDBogusA selector: #one)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 12/21/2006 22:22'!
testMultiString
	| ws |
	ws _ Smalltalk classNamed: 'WideString'.
	ws ifNotNil:
		[self assertEqualityOf: (ws fromString: 'abc')]! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:27'!
testOneByteInteger
	self assertEqualityOf: 7! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:26'!
testPoolImportElement
	self assertEqualityOf: (MDPoolImportElement className: #MDBogusA poolName: #MDBogusPoolA)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:58'!
testPropertyDictionary
	| properties |
	properties _ MDPropertyDictionary new.
	properties
		first: 1;
		second: 'two'.
	self assertEqualityOf: properties! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:41'!
testSnapshot
	self assertEqualityOf: self snapshot ! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 17:22'!
testString
	self assertEqualityOf: 'abc'.! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 17:15'!
testSymbol
	self assertEqualityOf: #one using: [:before :after | self assert: before == after]! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 05:26'!
testTimestamp
	| ts buffer |
	ts _ MDTimestamp now.
	buffer _ MDMarshal serialize: ts.
	self assert: buffer size = 5.
	self assert: (MDMarshal materialize: buffer) = ts! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:44'!
testTwoByteInteger
	self assertEqualityOf: 355! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 21:34'!
testUnrecognizedClass
	self
		should: [MDMarshal serialize: 'abc' asText]
		raise: Error! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:42'!
testVersion
	self 
		assertEqualityOf: self version 
		using: [:before :after |
				self assert: before variant = after variant.
				self assert: before hashstamp = after hashstamp.
				self assert: before ancestry = after ancestry]! !

!MDTestCase class methodsFor: 'as yet unclassified' stamp: 'cwp 3/2/2005 22:35'!
isAbstract
	^ self name = #MDTestCase! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:43'!
definition
	^ MDDefinitionVariant forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:44'!
definition: aSymbol
	| definition |
	definition _ MDDefinitionVariant forElement: (self element: aSymbol).
	definition properties at: #one put: 1.
	^ definition! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element
	^ self element: #Alpha! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element: aSymbol
	^ MDFakeElement named: aSymbol! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
elements
	^ Set
		with: (MDFakeElement named: #Alpha)
		with: (MDFakeElement named: #Beta)! !

!MDTestCase methodsFor: 'asserting' stamp: 'cwp 3/2/2005 22:51'!
fail
	self signalFailure: 'Assertion failed'! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal
	^ MDRemovalVariant forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal: aSymbol
	^ MDRemovalVariant forElement: (self element: aSymbol)! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:09'!
snapshot
	^ self snapshot: [:versions | ].
! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/23/2005 22:59'!
snapshot: aBlock
	| versions |
	versions _ Set new.	
	versions 
		add: (self versionFor: #Alpha with: 'alpha');
		add: (self versionFor: #Beta with: 'beta')	.
	aBlock value: versions.
	^ MDSnapshot withVersions: versions! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:12'!
updateVersion: anElementVersion property: aSymbol put: anObject 
	| newVariant |
	newVariant := anElementVersion variant copy.
	newVariant properties at: aSymbol put: anObject.
	^MDElementVersion 
		variant: newVariant
		ancestry: anElementVersion fullAncestry! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:39'!
version
	^ MDElementVersion variant: self definition! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:55'!
versionFor: elementName
	^ self versionFor: elementName with: elementName asLowercase! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:40'!
versionFor: elementName with: value
	| element snapshot |
	element _ MDFakeElement named: elementName.
	snapshot _ MDDefinitionVariant forElement: element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:40'!
versionWith: value
	| snapshot |
	snapshot _ MDDefinitionVariant forElement: self element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

TestCase subclass: #MDTimestampPrinterTest
	instanceVariableNames: 'ts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/9/2005 02:50'!
assert: format prints: expected
	| actual |
	actual _ ts printFormat: format.
	self assert: expected = actual! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2005 19:23'!
testNativePrintOn
	ts _ MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 3
			minute: 2
			second: 1.
	self assert: '%e %B %Y %i:%M:%S %p' prints: '4 May 2006 3:02:01 am'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2005 19:29'!
testSqueakMethodStampAm
	ts _ MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 1
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 01:02'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2005 19:29'!
testSqueakMethodStampPm
	ts _ MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 15
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 15:02'! !

TestCase subclass: #MDTimestampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 9/11/2005 18:22'!
intWithBytes: anArray
	| int |
	int _ 0.
	1 to: 4 do: [:i | int _ (int bitShift: 8) + (anArray at: i)].
	^ int! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 4/7/2005 22:26'!
recompose: units
	| int |
	int _ MDTimestamp compose: units.
	^ (MDTimestamp fromInteger: int) decompose! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:24'!
testAsInteger
	| int ts |
	int _ self intWithBytes: #(1 2 3 4).
	ts _ MDTimestamp fromInteger: int.
	self assert: ts asInteger = int.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:24'!
testByteOrder
	| ts |
	ts _ self tsWithBytes: #(1 2 3 4).
	self assert: (ts byteAt: 1) = 1.
	self assert: (ts byteAt: 2) = 2.
	self assert: (ts byteAt: 3) = 3.
	self assert: (ts byteAt: 4) = 4.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/24/2005 23:00'!
testComposition1
	| units |
	units _ #(1 2 3 4 5 6 7).
	self assert: (self recompose: units) = units! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/7/2005 22:55'!
testComposition2
	| before after |
	before _ #(7 3 5 4 3 2 1).
	after _ self recompose: before.
	self assert: before = after! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/16/2005 16:50'!
testDays
	self assert: (self ts: #(2001 02 23 00 00 00)) day = 23.
	self assert: (self ts: #(2001 02 23 00 00 01)) day = 23.
	self assert: (self ts: #(2001 02 23 23 59 59)) day = 23.
	self assert: (self ts: #(2005 02 23 12 00 00)) day = 23.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 01:38'!
testEndOfEpoch
	self 
	should: [MDTimestamp fromInteger: MDTimestamp last asInteger + 1]
	raise: Error! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 05:09'!
testEpoch
	| ts |
	ts _ MDTimestamp epoch.
	self assert: ts byteSize <= 4.
	self assert: ts asInteger = 0! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 04:54'!
testEquality
	| left right |
	left _ MDTimestamp now.
	right _ left copy.
	self deny: left == right.
	self assert: left = right.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/7/2005 23:35'!
testFromSqueakMethodStamp
	| ts |
	ts _ MDTimestamp fromSqueakMethodStamp: 'cwp 4/7/2005 01:30'.
	self assert: ts printString = '7 April 2005 1:30:00 am'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour01
	self assert: (self ts: #(2001 02 23 00 00 00)) hour = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour02
	self assert: (self ts: #(2001 02 23 01 00 01)) hour = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour03
	self assert: (self ts: #(2001 02 23 23 59 59)) hour = 23.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:20'!
testHour04
	self assert: (self ts: #(2005 04 07 01 30 00)) hour = 1.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 23:02'!
testLeapYear
	| ts |
	ts := self ts: #(2004 02 29 01 00 00).
	self assert: ts day = 29.
	self assert: ts month = 2! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:28'!
testMagnitude01
	| a b |
	a _ self tsWithBytes: #(1 2 3 4).
	b _ self tsWithBytes: #(1 2 3 5).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:29'!
testMagnitude02
	| a b |
	a _ self tsWithBytes: #(1 2 3 4).
	b _ self tsWithBytes: #(1 2 3 4).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:29'!
testMagnitude03
	| a b |
	a _ self tsWithBytes: #(1 2 3 4).
	b _ self tsWithBytes: #(1 2 3 3).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:31'!
testMagnitude04
	| a b |
	a _ self tsWithBytes: #(1 2 3 4).
	b _ self tsWithBytes: #(1 2 4 4).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute01
	self assert: (self ts: #(2001 02 23 00 00 00)) minute = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute02
	self assert: (self ts: #(2001 02 23 01 01 01)) minute = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute03
	self assert: (self ts: #(2001 02 23 23 59 59)) minute = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 01:21'!
testMonths
	| base increment ts |
	base _  24969600. 			"Value of Dec 15, the year of the epoch"
	increment _ 86400 * 30.		"Number of seconds in 30 days"
	
	"Start at Jan 15, and add 30 days at a time, to test each month."
	1 to: 12 do: 
		[:i | 
		ts _ MDTimestamp fromInteger: i * increment + base.
		self assert: ts month = i]! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/5/2005 21:49'!
testNow
	| ts |
	ts _ MDTimestamp now.
	self assert: ts size <= 4.
	self assert: ts asInteger positive! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting1
	| ts |
	ts := self ts: #(2000 03 01 00 00 00).
	self assert: ts printString = '1 March 2000 12:00:00 am'.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting2
	| ts |
	ts := self ts: #(2005 04 07 23 28 31).
	self assert: ts printString = '7 April 2005 11:28:31 pm'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting3
	| ts |
	ts := self ts: #(2005 04 07 03 28 31).
	self assert: ts printString = '7 April 2005 3:28:31 am'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 01:48'!
testRange
	| begin end |
	begin _ MDTimestamp epoch.
	end _ MDTimestamp last.
	self assert: MDTimestamp range = (end asInteger - begin asInteger)! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond01
	self assert: (self ts: #(2001 02 23 00 00 00)) second = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond02
	self assert: (self ts: #(2001 02 23 01 01 01)) second = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond03
	self assert: (self ts: #(2001 02 23 23 59 59)) second = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear01
	self assert: (self ts: #(1984 02 28 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear02
	self assert: (self ts: #(1984 02 29 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear03
	self assert: (self ts: #(1984 03 01 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear04
	self assert: (self ts: #(2001 02 23 00 01 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear05
	self assert: (self ts: #(2001 02 28 23 59 59)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear06
	self assert: (self ts: #(2001 03 01 00 00 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear07
	self assert: (self ts: #(2001 03 01 00 00 01)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear08
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:30'!
testYear09
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:38'!
testYear10
	self assert: (self ts: #(2004 02 23 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:33'!
testYear11
	self assert: (self ts: #(2004 02 29 00 01 00)) year = 2004.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear12
	self assert: (self ts: #(2004 04 29 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear13
	self assert: (self ts: #(2005 02 23 00 01 00)) year = 2005.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 20:30'!
testYear14
	self assert: (self ts: #(2004 01 07 09 11 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 6/18/2005 16:04'!
ts: anArray
	| parts |
	parts := Array new: 6.
	parts atAllPut: 0.
	anArray withIndexDo: [:ea :i | parts at: i put: ea].
	^ MDTimestamp
		year: (parts at: 1)
		month: (parts at: 2)
		day: (parts at: 3)
		hour: (parts at: 4)
		minute: (parts at: 5)
		second: (parts at: 6)! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 9/11/2005 18:25'!
tsWithBytes: anArray
	^ MDTimestamp fromInteger: (self intWithBytes: anArray)! !

Dictionary subclass: #MDPropertyDictionary
	instanceVariableNames: 'localReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPropertyDictionary commentStamp: 'cwp 5/9/2006 23:27' prior: 0!
I store the state of particular variant of an element. !

!MDPropertyDictionary class methodsFor: 'serializing' stamp: 'cwp 3/9/2005 21:17'!
materializeWith: aMarshal
	^ aMarshal readDictionaryOfClass: self! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'cwp 4/3/2005 20:33'!
at: key
	^ self at: key ifAbsent: [nil]! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'cwp 4/3/2005 20:31'!
at: key put: anObject
	anObject ifNotNil: [super at: key put: anObject]! !

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 4/3/2005 20:36'!
doesNotUnderstand: aMessage
	aMessage selector isUnary ifTrue: [^ self at: aMessage selector].
	(aMessage selector isKeyword
		and: [aMessage arguments size = 1])
			ifTrue: [^ self
						at: aMessage selector allButLast asSymbol
						put: aMessage arguments first].
	super doesNotUnderstand: aMessage.! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'avi 3/14/2005 18:08'!
localReference
	^ localReference! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'avi 3/14/2005 18:08'!
localReference: anObject
	localReference _ anObject! !

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 12/31/2006 01:09'!
name
	^ self at: #name! !

!MDPropertyDictionary methodsFor: 'serializing' stamp: 'cwp 4/24/2005 22:59'!
serializeWith: aMarshal
	aMarshal writeDictionary: self! !

Magnitude variableByteSubclass: #MDHashstamp
	instanceVariableNames: ''
	classVariableNames: 'CharMap'
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDHashstamp class methodsFor: 'serializing' stamp: 'cwp 3/11/2005 23:30'!
decodeString: aString
	| write read a b c d |
	write _ (ByteArray new: 24) writeStream.
	read _ aString readStream.
	[read atEnd] whileFalse:
		[a _ (CharMap indexOf: read next) - 1.
		b _ (CharMap indexOf: read next) - 1.
		write nextPut: (a bitShift: 2) + (b bitShift: -4).
		b _ b bitAnd: 16rF.
		c _ (CharMap indexOf: read next) - 1.
		write nextPut: (b bitShift: 4) + (c bitShift: -2).
		c _ c bitAnd: 16r3.
		d _ (CharMap indexOf: read next) - 1.
		write nextPut: (c bitShift: 6) + d].
	^ write contents! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 05:02'!
forObject: anObject 
	^ self forObject: anObject timestamp: MDTimestamp now! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 3/25/2005 20:37'!
forObject: anObject timestamp: aTimestamp
	^ self 
		hashIn: [:stream | (MDMarshal on: stream) serialize: anObject]
		timestamp: aTimestamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 4/18/2005 13:48'!
fromBytes: aByteArray
	| hashstamp |
	aByteArray size = 24 ifFalse: [self error: 'Incorrect byte size'].
	hashstamp _ self new.
	1 to: 24 do: [:i | hashstamp byteAt: i put: (aByteArray at: i)].
	^ hashstamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'avi 3/14/2005 12:46'!
fromString: aString
	^ self fromBytes: (self decodeString: aString)! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 05:01'!
hashIn: aBlock
	^ self hashIn: aBlock timestamp: MDTimestamp now! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 3/25/2005 20:37'!
hashIn: aBlock timestamp: aTimestamp
	| sha stream |
	stream _ RWBinaryOrTextStream on: ByteArray new.
	aBlock value: stream.
	sha _ SecureHashAlgorithm new.
	^ self new setHash: (sha hashMessage: stream contents) timestamp: aTimestamp! !

!MDHashstamp class methodsFor: 'initialize-release' stamp: 'cwp 9/8/2005 07:39'!
initialize
	CharMap _ '+-0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.! !

!MDHashstamp class methodsFor: 'serializing' stamp: 'cwp 4/18/2005 13:42'!
materializeWith: aMarshal
	^ aMarshal readBytes: self new! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 4/18/2005 12:58'!
new
	^ self new: 24! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 18:50'!
< other
	| selfByte otherByte |
	1 to: self byteSize do: 
		[:i | 
			selfByte _ self byteAt: i.
			otherByte _ other byteAt: i.
			(selfByte == otherByte) ifFalse: [^ selfByte < otherByte]].
	^ false! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:56'!
= other
	self class = other class ifFalse: [^ false].
	1 to: self size do: [:i | (self at: i) = (other at: i) ifFalse: [^ false]].
	^ true! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:17'!
byteAt: index
	^ self basicAt: index! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:41'!
byteAt: index put: value
	self basicAt: index put: value! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:46'!
byteSize
	^ self basicSize! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 4/18/2005 13:08'!
bytes
	| bytes |
	bytes _ ByteArray new: self size.
	bytes replaceFrom: 1 to: self size with: self startingAt: 1.
	^ bytes! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 4/18/2005 13:47'!
digest
	| hash |
	hash _ LargePositiveInteger basicNew: 20.
	1 to: 20 do: [:i | hash digitAt: i put: (self at: i + 4)].
	^ hash! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 4/18/2005 13:35'!
hash
	^ByteArray
		hashBytes: self
		startingWith: self species hash! !

!MDHashstamp methodsFor: 'printing' stamp: 'cwp 3/10/2005 00:45'!
printFirst: first second: second third: third on: aStream
	| a b c d |
	a _ first bitShift: -2.
	b _ ((first bitShift: 4) bitOr: (second bitShift: -4)) bitAnd: 16r3F.
	c _ ((second bitShift: 2) bitOr: (third bitShift: -6)) bitAnd: 16r3F.
	d _ third bitAnd: 16r3F.
	
	aStream
		nextPut: (CharMap at: a+1);
		nextPut: (CharMap at: b+1);
		nextPut: (CharMap at: c+1);
		nextPut: (CharMap at: d+1)! !

!MDHashstamp methodsFor: 'printing' stamp: 'avi 3/14/2005 12:43'!
printOn: aStream
	| bytes |
	bytes _ self bytes.
	1 to: 24 by: 3 do: [:i | self 
							printFirst: (bytes at: i) 
							second: (bytes at: i+1)
							third: (bytes at: i+2)
							on: aStream].! !

!MDHashstamp methodsFor: 'private' stamp: 'cwp 4/18/2005 13:32'!
replaceFrom: start to: end with: bytes
	| offset |
	offset _ start - 1.
	1 to: (end - offset) do: [:i | self basicAt: offset + i put: (bytes basicAt: i)]! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 4/18/2005 13:44'!
serializeWith: aMarshal
	aMarshal writeBytes: self! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 4/18/2005 13:33'!
setHash: aLargeInteger timestamp: aTimestamp
	self replaceFrom: 1 to: 4 with: aTimestamp.
	self replaceFrom: 5 to: 24 with: (aLargeInteger withAtLeastNDigits: 20)! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 4/18/2005 13:15'!
timestamp
	^ MDTimestamp fromHashstamp: self! !

Magnitude variableByteSubclass: #MDTimestamp
	instanceVariableNames: ''
	classVariableNames: 'MDMinute MDDay MDYear MDHour MDSecond MDLeapCycle MDMonths'
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

MDTimestamp class
	instanceVariableNames: 'parts'!

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
compose: units
	| int accumulate |
	parts _ units readStream.
	accumulate _ [:ea | int _ parts next * ea + int].
	int _ 0.
	self highConstants do: accumulate.
	(MDMonths first: parts next) do: [:ea | int _ ea + int].
	self lowConstants do: accumulate.
	^ int! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 05:04'!
epoch
	^ self new! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:29'!
epochYear
	^ 1980! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 4/18/2005 13:17'!
fromHashstamp: hashstamp
	| inst |
	inst _ self new.
	1 to: 4 do: [:i | inst byteAt: i put: (hashstamp byteAt: i)].
	^ inst! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 9/10/2005 23:36'!
fromInteger: int	
	| ts |
	int > self range ifTrue: [self error: 'Timestamp out of range'].
	ts _ self new: 4.
	ts byteAt: 1 put: (int bitShift: -24).
	ts byteAt: 2 put: ((int bitShift: -16) bitAnd: 16rFF).
	ts byteAt: 3 put: ((int bitShift: -8) bitAnd: 16rFF).
	ts byteAt: 4 put: (int bitAnd: 16rFF).
	^ ts! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 6/18/2005 16:04'!
fromSqueakMethodStamp: aString
	| stream month day year hour minute |
	stream := ReadStream on: aString.
	[stream peek isDigit] whileFalse: [stream next].
	month := (stream upTo: $/) asNumber.
	day := (stream upTo: $/) asNumber.
	year := (stream upTo: Character space) asNumber.
	hour := (stream upTo: $:) asNumber.
	minute := (stream upTo: Character space) asNumber.
	stream atEnd ifFalse: [(stream next: 2) = 'pm' ifTrue: [hour := hour + 12]].
	^ self year: year month: month day: day hour: hour minute: minute second: 0! !

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:16'!
highConstants
	^ Array
		with: MDLeapCycle
		with: MDYear! !

!MDTimestamp class methodsFor: 'initializing' stamp: 'cwp 4/7/2005 22:50'!
initialize
	MDSecond _ 1.
	MDMinute _ 60 * MDSecond.
	MDHour _ 60 * MDMinute.
	MDDay _ 24 * MDHour.
	MDYear _ MDDay * 365.
	MDLeapCycle _ MDYear * 4 + MDDay.
	self initializeMonths.
	! !

!MDTimestamp class methodsFor: 'initializing' stamp: 'cwp 4/9/2005 04:14'!
initializeMonths
	MDMonths _ #(31 30 31 30 31 31 30 31 30 31 31) collect: [:ea | ea * MDDay].
! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:40'!
last
	^ self fromInteger: self range! !

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
lowConstants
	^ Array
		with: MDDay
		with: MDHour
		with: MDMinute
		with: MDSecond! !

!MDTimestamp class methodsFor: 'serialization' stamp: 'cwp 4/18/2005 13:41'!
materializeWith: aMarshal
	^ aMarshal readBytes: self new! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 05:04'!
new
	^ self new: 4! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 6/18/2005 16:04'!
now
	| platform |
	platform := MDPlatform current.
	^ self fromInteger: platform secondClock + platform clockOffset.! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:43'!
range
	^ 3786825599! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 4/16/2005 17:03'!
year: aYear month: aMonth day: day hour: hour minute: minute second: second
	| year month units |
	aMonth < 3 
		ifTrue: [year _ aYear - self epochYear - 1. month _ aMonth + 10]
		ifFalse: [year _ aYear - self epochYear. month _ aMonth - 2].
	units _ Array new: 7.
	units at: 1 put: year // 4.
	units at: 2 put: year \\ 4.
	units at: 3 put: month - 1.
	units at: 4 put: day - 1.
	units at: 5 put: hour.
	units at: 6 put: minute.
	units at: 7 put: second.
	^ self fromInteger: (self compose: units)! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:25'!
< other
	^ self asInteger < other asInteger! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:25'!
= other
	self class == other class ifFalse: [^ false].
	self byteSize = other byteSize ifFalse: [^ false].
	^ self asInteger = other asInteger! !

!MDTimestamp methodsFor: 'converting' stamp: 'cwp 9/10/2005 23:30'!
asInteger
	| integer |
	integer := 0.
	1 to: self size do: [:i | integer := (integer bitShift: 8) + (self byteAt: i)].
	^ integer! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/5/2005 21:19'!
byteAt: index
	^ self basicAt: index! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/5/2005 21:20'!
byteAt: index put: byte
	^ self basicAt: index put: byte! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:59'!
byteSize
	^ self basicSize! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
day
	^ (self decompose at: 4) + 1! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/21/2005 02:21'!
decompose
	| results int reduce |
	results _ (Array new: 7) writeStream.
	int _ self asInteger.
	reduce _ [:unit | results nextPut: int // unit. int _ int \\ unit].
	reduce value: MDLeapCycle.
	int _ self reduceYearsIn: int on: results.
	int _ self reduceMonthsIn: int on: results.
	self lowConstants do: reduce.
	^ results contents! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/9/2005 01:14'!
epochYear
	^ self class epochYear! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 18:28'!
hash
	^ self asInteger hash! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
highConstants
	^ self class highConstants! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
hour
	^ self decompose at: 5! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/16/2005 16:18'!
lowConstants
	^ self class lowConstants! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
minute
	^ self decompose at: 6! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:27'!
month
	^ self monthFrom: self decompose! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 6/18/2005 16:04'!
monthFrom: anArray
	^ (anArray at: 3) + 2 \\ 12 + 1! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/9/2005 02:55'!
printFormat: aString
	^ self printer printFormat: aString! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/9/2005 04:23'!
printOn: aStream
	self printer printOn: aStream format: '%e %B %Y %i:%M:%S %p' ! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 6/18/2005 16:04'!
printer
	| units |
	units := self decompose.
	^ MDTimestampPrinter
		year: (self yearFrom: units)
		month: (self monthFrom: units)
		day: (units at: 4) + 1
		hours: (units at: 5)
		minutes: (units at: 6)
		seconds: (units at: 7)! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 6/18/2005 16:04'!
reduceMonthsIn: anInteger on: aStream
	| months int |
	months := 0.
	int := anInteger.
	MDMonths do: [:ea | 
				int < ea
					ifTrue: [aStream nextPut: months. ^ int]
					ifFalse: [int := int - ea].
				months := months + 1].
	aStream nextPut: months.
	^ int! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/21/2005 02:37'!
reduceYearsIn: anInteger on: aStream
	| years |
	years := anInteger // MDYear min: 3.
	aStream nextPut: years.
	^ anInteger - (MDYear * years)! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
second
	^ self decompose at: 6! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/18/2005 13:45'!
serializeWith: aMarshal
	aMarshal writeBytes: self! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 8/9/2005 21:21'!
timestamp
	^ self! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:29'!
year
	^ self yearFrom: self decompose! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/20/2005 21:48'!
yearFrom: anArray
	| years |
	years := anArray first * 4 + (anArray at: 2).
	years := years + self epochYear.
	^ (anArray at: 3) < 10 ifTrue: [years] ifFalse: [years + 1]! !

!String class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:56'!
materializeWith: aMarshal
	^ aMarshal readStringOfClass: self! !

!String methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:13'!
serializeWith: aMarshal
	aMarshal writeString: self! !

!Integer methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:14'!
serializeWith: aMarshal
	aMarshal writeSmallInteger: self! !

Notification subclass: #MDLogMessageRequest
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDLogMessageRequest class methodsFor: 'signalling' stamp: 'cwp 3/15/2005 23:41'!
update: aPropertyDictionary
	^ (self new properties: aPropertyDictionary) signal! !

!MDLogMessageRequest methodsFor: 'accessing' stamp: 'cwp 3/15/2005 23:44'!
defaultAction
	self properties author: Utilities authorInitials.
	self resume! !

!MDLogMessageRequest methodsFor: 'accessing' stamp: 'cwp 3/15/2005 23:41'!
properties
	^ properties! !

!MDLogMessageRequest methodsFor: 'accessing' stamp: 'cwp 3/15/2005 23:41'!
properties: aPropertyDictionary
	properties _ aPropertyDictionary! !

Notification subclass: #MDMergeRequest
	instanceVariableNames: 'wc merges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDMergeRequest class methodsFor: 'signalling' stamp: 'avi 3/21/2006 00:15'!
includeAll: versions in: aWorkingCopy
	| instance merges |
	instance _ self new.
	merges _ versions collect: [:ea | MDMerge toInclude: ea in: aWorkingCopy].
	merges _ merges reject: [:ea | ea isNoOp].
	instance merges: merges.
	instance workingCopy: aWorkingCopy.
	^ instance signal! !

!MDMergeRequest methodsFor: 'exceptionDescription' stamp: 'cwp 3/2/2006 14:54'!
defaultAction
	MDMergeTool openOn: merges in: wc! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 3/25/2005 21:23'!
merges
	^ merges! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 3/25/2005 21:23'!
merges: aCollection
	merges _ aCollection! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 3/2/2006 14:45'!
workingCopy
	^ wc! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 3/2/2006 14:45'!
workingCopy: aWorkingCopy
	wc _ aWorkingCopy! !

!Set class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:15'!
materializeWith: aMarshal
	^ aMarshal readSetOfClass: self! !

!Set methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:40'!
serializeWith: aMarshal
	aMarshal writeSet: self! !

!Boolean class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:52'!
materializeWith: aMarshal
	^ aMarshal readBooleanOfClass: self! !

!Boolean methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:50'!
serializeWith: aMarshal
	aMarshal writeBoolean: self! !
MDMarshal initialize!
MDTimestampPrinter initialize!
MDHashstamp initialize!
MDTimestamp initialize!
